import Bladex
import CharStats
import Reference
import Actions
import math
import AuxFuncs
import InitDataField
import Objects
import whrandom
import BCopy
import B3DLib
import Damage
import Auras
import GenFX
import ObjStore
import GameStateAux
import ItemTypes
import MenuText
import AuxFuncs
import darfuncs

import LittleImpTypes








Bladex.AddParticleGType("Tierra3","GenericParticle",Reference.B_PARTICLE_GTYPE_BLEND,60)

for i in range(60):
	aux=(60-i)/60
	r=40
	g=30
	b=0
	a=255*(1.0-aux/2.0)
	size=60.0*(1.0-aux)
	Bladex.SetParticleGVal("Tierra3",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("Tierra2","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	aux=(64.0-i)/64.0
	r=210
	g=190
	b=140
	a=255.0*(1.0-aux)**0.5
	size=80.0+aux*400.0
	Bladex.SetParticleGVal("Tierra2",i,r,g,b,a,size)


Bladex.AddParticleGType("Tierra2sub","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	aux=(64.0-i)/64.0
	r=200
	g=140
	b=100
	a=255.0*(1.0-aux)**0.5
	size=80.0+aux*400.0
	Bladex.SetParticleGVal("Tierra2sub",i,r,g,b,a,size)













class ImpHole (ItemTypes.PersistantItemType):

	def __init__(self, me, entitykind):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.Active=1
		self.Name=me.Name
		self.Impnum=0
		self.trsectorname=""
		self.EntityKind=entitykind
		self.DustFX=1
		
		self.GenSound=Bladex.CreateEntity (me.Name+"GenSound", "Entity Sound", 0, 0, 0)
		self.GenSound.SetSound("..\\..\\Sounds\\M-GENERADOR-ENTIERRA3.wav")
		self.GenSound.MinDistance=5000
		self.GenSound.MaxDistance=20000
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.SetTrigger, ())
		


	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ImpHole"]=(self.trsector_name,
						self.Active,
						self.Impnum,
						self.GenSound.Name,
						self.Name,
						self.EntityKind,
						self.DustFX
						)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ImpHole"]
			self.trsector_name=parms[0]
			self.Active=parms[1]
			self.Impnum=parms[2]
			self.GenSound= Bladex.GetEntity(parms[3])
			self.Name=parms[4]
			self.EntityKind=parms[5]
			self.DustFX=parms[6]
			
		else:
			self.trsector_name=""
			self.Active=1
			self.Impnum=0
			self.GenSound= Bladex.GetEntity(self.Name+"GenSound")
			self.Name=""
			self.EntityKind="Skeleton"
			self.DustFX=1


	def SetTrigger(self, radius=2000.0, floor_displ=1000.0, roof_displ=2000.0):
		x = Bladex.GetEntity(self.Name).Position[0]
		y = Bladex.GetEntity(self.Name).Position[1]
		z = Bladex.GetEntity(self.Name).Position[2]
		dx=radius/2.0
		dz=radius*((math.sqrt(3.0))/2.0)
		self.trsector_name=self.Name+"_TrSector"
		Bladex.AddTriggerSector(self.trsector_name, "SectoresTriggerImpHole", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
		Bladex.SetTriggerSectorFunc(self.trsector_name, "OnLeave", self.InitSpawnImp)
		print "Imp Trigger Set"
		

	def InitSpawnImp(self,sector,entity):
		per=Bladex.GetEntity(entity)
		if per.Name=="Player1":
			if per.Life>0:
				if self.Active==1:
					self.Active=0
					print"Try to spawn Imp"
					self.TryToSpawnImp(self.Name)
				
				
				
	def TryToSpawnImp(self,EntityName):
		x, y, z = Bladex.GetEntity(EntityName).Position
		ents=Bladex.GetEntitiesAt(x, y, z, 3000)
		for id in ents:
			o = Bladex.GetEntity(id)
			if o.Person:
				if o.Life > 0:
					if o.Alpha >0.01:
						print "Trying to do it, but",id,"is bothering. Next try in 3 seconds."
						Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.TryToSpawnImp,(self.Name,))
						return
		self.CreateImp(EntityName)
		print"All clear -> create SKEL"
					
					
	def CreateImp(self,EntityName):
		print "start spawn Imp"
		x, y, z = Bladex.GetEntity(EntityName).Position
		char= Bladex.GetEntity("Player1")
		lvl=char.Level
		self.Impnum = self.Impnum +1
		if not self.EntityKind:
			return
		if not self.EntityKind == "LittleImp_Air":
			return
		imp=Bladex.CreateEntity(self.Name+"GenImp"+`self.Impnum`,self.EntityKind, x, y+1100, z,"Person")
		imp.Data=LittleImpTypes.LittleImp(imp)
		print "Spawned TP skel getting data"
		
		imp.Angle=0.0
		imp.Level=lvl
		imp.Blind=1
		imp.Deaf=1
		imp.Freeze()
		imp.Life=CharStats.GetCharMaxLife(imp.Kind,imp.Level)
		
		darfuncs.HideBadGuy(imp.Name)
		self.SpawnImp(EntityName,imp.Name)
		
		
		
	def SpawnImp(self,EntityName,ImpName):
		x, y, z = Bladex.GetEntity(EntityName).Position
		char= Bladex.GetEntity("Player1")
		imp=Bladex.GetEntity(ImpName)
		
		pos=imp.Position
		if self.DustFX:
			v=char.Position[0]-pos[0], 0.0, char.Position[2]-pos[2]
			v=B3DLib.Normalize(v)
			v1=v[0]*500.0, 0.0, v[2]*500.0
			v2=v1[0]*math.cos(1.7453)-v1[2]*math.sin(1.7453), 0.0, v1[0]*math.sin(1.7453)+v1[2]*math.cos(1.7453)
			v3=v2[0]*math.cos(2.7925)-v2[2]*math.sin(2.7925), 0.0, v2[0]*math.sin(2.7925)+v2[2]*math.cos(2.7925)
			saltatie=Bladex.CreateEntity("TierraSaltando", "Entity Particle System D1", pos[0], pos[1]-1200.0, pos[2])
			saltatie.ParticleType="Tierra3"
			saltatie.PPS=1024
			saltatie.YGravity=4900.0
			saltatie.Friction=0.05
			saltatie.Velocity=0.0, -600.0, 0.0
			saltatie.RandomVelocity=50.0
			saltatie.Time2Live=60
			saltatie.DeathTime=Bladex.GetTime()+10.0/60.0
			saltati2=Bladex.CreateEntity("TierraSaltando2", "Entity Particle System D1", pos[0], pos[1]-1200.0, pos[2])
			saltati2.ParticleType="Tierra2"
			saltati2.PPS=128
			saltati2.YGravity=200.0
			saltati2.Friction=0.1
			saltati2.Velocity=0.0, -300.0, 0.0
			saltati2.RandomVelocity=15.0
			saltati2.Time2Live=32
			saltati2.DeathTime=Bladex.GetTime()+10.0/60.0
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.RemueveTierra, (pos, v1, v2, v3,))
			self.GenSound.Position=x, y, z
			self.GenSound.PlaySound(0)
		imp.Blind=1
		imp.Deaf=1
		darfuncs.UnhideBadGuy(imp.Name)
		imp.SetTmpAnmFlags(1,1,1,0,5,1,0)
		imp.LaunchAnimation("Skl_appears1")
		alfa=B3DLib.GetEntity2EntityAngle(imp.Name, "Player1")
		imp.Angle=alfa
		darfuncs.CreateFalseCube(imp.Position,-1.0,imp.Name)
		anmtime=Bladex.GetAnimationDuration("Skl_appears1")
		Bladex.AddScheduledFunc(Bladex.GetTime()+anmtime,self.Despierta,(ImpName,))
		
				

	
	def RemueveTierra(self, pos, v1, v2, v3):
		tierra=Bladex.CreateEntity("TierraRemoviendose", "Entity Particle System D3", pos[0]+v1[0], pos[1]-1200.0, pos[2]+v1[2])
		tierra.D1=v2[0]-v1[0], 0.0, v2[2]-v1[2]
		tierra.D2=v3[0]-v1[0], 0.0, v3[2]-v1[2]
		tierra.ParticleType="Tierra2"
		tierra.PPS=64
		tierra.YGravity=200.0
		tierra.Friction=0.1
		tierra.Velocity=0.0, -400.0, 0.0
		tierra.RandomVelocity=15.0
		tierra.Time2Live=64
		tierra.DeathTime=Bladex.GetTime()+2.0	
				
				
	def Despierta(self,ImpName):
		print "Despierta"
		o = Bladex.GetEntity(ImpName + "quad")
		if o:
			o.SubscribeToList("Pin")
		imp=Bladex.GetEntity(ImpName)
		imp.SetOnFloor()
		Bladex.AddScheduledFunc(Bladex.GetTime()+180.0, self.RemoveMe,(imp.Name,))
				
				
	def RemoveMe(self,ImpName):
		self.Active=1
		imp = Bladex.GetEntity(ImpName)
		if imp:
			if imp.Life>0:
				imp.Life=0
		else:
			print "Imp already killed"


		
def CreateSkelHole(name, pos, visible=1, dustfx=1, EntityKind="LittleImp_Air", scale=1.2):
	offset=1000   # Knight hight
	hole=Bladex.CreateEntity(name,"ProGeyser1",pos[0],pos[1]+offset,pos[2])
	hole.Scale=scale
	hole.Orientation=(0.707,0.707,0.0,0.0)
	if not visible:
		hole.Alpha=0
		hole.CastShadows=0
	hole.Data=ImpHole(hole, EntityKind)
	if dustfx:
		hole.Data.DustFX=1
	else:
		hole.Data.DustFX=0
	return hole.Data	