import Bladex
import Enm_Def
import AuxFuncs
import CharStats
import GenFX
import whrandom
import Actions
import Reference
import GameStateAux
import AniSound
import Combat
import BCopy
import Basic_Funcs
import Damage
import ItemTypes
import InitDataField
import Sparks
import DMusic
import ScorerActions

import PlayerTypes
import AniSoundHaedraline
import AniSoundGoblin
import AniSoundMorag
import GoblinWeaponTypes

TRUE = 1==1
FALSE = not TRUE



CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear







def CheckIfEnemy (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:		
		try:
	           	enemyName=me.Data.EnemyName
	           	return TRUE                       
	        except AttributeError:  
	 	   	return FALSE   

	 	   
def IsHoldingBow(EntityName):
	me=Bladex.GetEntity(EntityName)
	ObjectName=me.InvLeft
	object_flag=Reference.GiveObjectFlag(ObjectName)
	if object_flag==Reference.OBJ_BOW:
		return TRUE
	return FALSE
		
		
		
def KeepDistance (EntityName):
	me= Bladex.GetEntity(EntityName)
	return me.AnimName!="rlx"
	
	
		
def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
		
def RemoveMyCorpse(PersonName, dx, dz):
	#wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	#wps.PersonName=PersonName
	#wps.ParticleType="EnPolvo"
	#wps.Time2Live=64
	#wps.RandomVelocity=0
	#wps.Velocity=dx,300,dz
	#wps.NormalVelocity=2.0
	#wps.YGravity=-300
	#wps.DeathTime=Bladex.GetTime()+1.5
	#wps.PPS=300
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(me.Name,))
	
	
	
def RemoveMyWeapon(WeaponName):
	wp = Bladex.GetEntity(WeaponName)
	if wp:
		wp.Alpha=1.00
		wp.RasterMode="Read"
		wp.CastShadows=0
		AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))
		
		
		
def GiveWeaponType(entity):
	per=Bladex.GetEntity(entity)
	inv = per.GetInventory()
	rwp=per.InvRight
	if rwp:
		wpflag=Reference.GiveObjectFlag(rwp)
		if wpflag==Reference.OBJ_STANDARD:
			return W_FLAG_1H
	for x in range(inv.nWeapons):
		weapon_name = inv.GetWeapon(x)
		wp = Bladex.GetEntity(weapon_name)
		if wp:
			if Reference.EntitiesObjectData.has_key(weapon_name):
				object_data = Reference.EntitiesObjectData[weapon_name]
			else:
				object_data = Reference.DefaultObjectData[wp.Kind]
			
			if not object_data[0]==Reference.OBJ_BOW:
				return object_data[5][0]
				break
		else:
			return None
	
	
###########################################################################################################################################################
###### Arms


def  GetNewShield(EntityName,ShieldName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nshd=Bladex.GetEntity(ShieldName)
	inv.LinkLeftHand(ShieldName)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new shield
		return
	if per.Kind in ("Ork","Great_Ork","Knight_Traitor","Dark_Knight"):
		# These races have no change left anim 
		return
	per.Wuea=Reference.WUEA_ENDED	
	per.InterruptCombat()	
	per.LaunchAnmType("Chg_l")
	


def  GetNewWeapon(EntityName,WeaponName):
	per=Bladex.GetEntity(EntityName)
	inv=per.GetInventory()
	nwep=Bladex.GetEntity(WeaponName)
	owep=Bladex.GetEntity(per.InvRight)
	if inv.HoldingBow:
		# If you shot something, tough luck. No new weapon
		return
	if owep:
		per.Wuea=Reference.WUEA_ENDED	
		per.InterruptCombat()	
		per.LaunchAnmType("Chg_r_l")
		inv.LinkRightHand("")
		inv.RemoveWeapon(owep.Name)
		owep.Position=0,30000,0
		inv.LinkRightHand(WeaponName)


Weps={}  
Weps["Knight_Traitor"]=["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","HookSword","KingSword","EgyptSword","Espadacurva","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Dark_Knight"]=   ["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","HookSword","KingSword","EgyptSword","Espadacurva","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Goblin_A"]=      ["HookSword","HookSword","HookSword","HookSword","Hacha4","HookSword","Maza2","Maza2","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6","Hacha6"]




Shields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]

EnemyShieldholders=["Ork","Great_Ork","Knight_Traitor","Dark_Knight"]

############################################################################################################################################################
# LevelUp Functions. To set existing weapon damage as per Level or to switch weapons for more powerful one and replace broken shields.

def EnemyLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	PlayerTypes.CheckHighestLevel(EntityName)
	global Weps
	global Shields
	global EnemyShieldholders
	per=Bladex.GetEntity(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWWPTYPE=Weps[per.Kind][19]
		else:
			NEWWPTYPE=Weps[per.Kind][lvl]
		newwp=Bladex.CreateEntity(EntityName+"_Weapon_Level"+`lvl`,NEWWPTYPE,0,40000,0,"Weapon")
		ItemTypes.ItemDefaultFuncs(newwp)
		flag=Reference.GiveWeaponFlag(newwp.Name)
		per.Data.RegisterObjectAsTaken(newwp.Name)
		inv.AddWeapon(newwp.Name,flag)
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 1.5, GetNewWeapon, (EntityName,newwp.Name,))
		sh=Bladex.GetEntity(per.InvLeft)
		# only get a new shield if you have broken the old one
		if not sh and per.Kind in EnemyShieldholders:
			if lvl>19:
				NEWSHTYPE=Shields[19]
			else:
				NEWSHTYPE=Shields[lvl]
			newsh=Bladex.CreateEntity(EntityName+"_Shield_Level"+`lvl`,NEWSHTYPE,0,40000,0,"Weapon")
			ItemTypes.ItemDefaultFuncs(newsh)
			inv.AddShield(newsh.Name)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, GetNewShield, (EntityName,newsh.Name,))




MoragHit=[10,15,28,45,60,80,100,130,170,220,270,330,400,520,650,780,880,950,1080,1200]
HaedralineHit=[8,12,20,35,46,58,70,85,110,150,230,290,400,520,650,780,880,950,1080,1200]
HaedralineDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]

def HaedralineLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	global HaedralineHit
	global HaedralineDef
	per=Bladex.GetEntity(EntityName)
	PlayerTypes.CheckHighestLevel(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1500
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=HaedralineHit[lvl]
			NEWDEFENSE=HaedralineDef[lvl]
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
			Reference.EntitiesObjectData[rwp.Name]=Reference.DefaultObjectData[rwp.Kind]
			Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
			Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
			print EntityName+" My Weapon is upgraded"
	
	
def MoragLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	global MoragHit
	global HaedralineDef
	per=Bladex.GetEntity(EntityName)
	PlayerTypes.CheckHighestLevel(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1500
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=MoragHit[lvl]
			NEWDEFENSE=HaedralineDef[lvl]
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
			Reference.EntitiesObjectData[rwp.Name]=Reference.DefaultObjectData[rwp.Kind]
			Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
			Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
			print EntityName+" My Weapon is upgraded"
	
	
	
GoblinHit=[2,4,10,15,20,28,36,45,55,70,90,110,130,150,180,240,300,400,550,680]
GoblinDef=[0,-3, -5, -10, -15, -20, -25,-30, -35, -40, -45, -50, -55, -60, -65, -70,-75, -80,-85]
	
def GoblinLevelUpFunc(EntityName):
	print EntityName+" I have leveled up"
	global GoblinHit
	global GoblinDef
	per=Bladex.GetEntity(EntityName)
	PlayerTypes.CheckHighestLevel(EntityName)
	if per.Life>0:
		lvl=per.Level
		inv=per.GetInventory()
		if lvl>19:
			NEWDAMAGE=1500
			NEWDEFENSE=-120
		else:
			NEWDAMAGE=GoblinHit[lvl]
			NEWDEFENSE=GoblinDef[lvl]
		rwp=Bladex.GetEntity(per.InvRight)
		if rwp:
		 	if not inv.HoldingBow:
				Reference.EntitiesObjectData[rwp.Name]=Reference.DefaultObjectData[rwp.Kind]
				Reference.EntitiesObjectData[rwp.Name][1]= NEWDAMAGE
				Reference.EntitiesObjectData[rwp.Name][2]= NEWDEFENSE
				print EntityName+" My Weapon is upgraded"
			else:
				for x in range(inv.nWeapons):
					weapon_name = inv.GetWeapon(x)
					wp=Bladex.GetEntity(weapon_name)
					if wp and  Reference.GiveWeaponFlag(weapon_name)==Reference.W_FLAG_1H:
						Reference.EntitiesObjectData[weapon_name]= Reference.DefaultObjectData[rwp.Kind]
						Reference.EntitiesObjectData[weapon_name][1]= NEWDAMAGE
						Reference.EntitiesObjectData[weapon_name][2]= NEWDEFENSE
						print EntityName+" I am holding my catapult but still upgraded my sword"
						
	
###########################################################################################################################################################
############################# Base Enemy Class ####


class EnemyChar (Enm_Def.NPCPerson):

	DeathFunc=None
	DeathArgs=()
	LevelupFunc=None
	LevelupArgs=()
	NPCLevelUpParticleData=[]
	NameOfEnemy=None
	Dusted=1
	

	def __init__(self, me):
		Enm_Def.NPCPerson.__init__(self, me)
		
		me.ImDeadFunc=self.NewImDeadFunc
		
		self.NPCLevelUpParticleData=[]
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
			
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		
		
		
	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me = Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+30,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+35,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+36,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
		
							
							

	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+20, RemoveMyWeapon,(obj_name,))
			
			
			
	def StdEnemyDead(self,EntityName):
		Enm_Def.NPCPerson.StdEnemyDead(self,EntityName)
		Reference.debugprint(EntityName+": My enemy is really dead.He he ! - py")
		if not self.MyGetEnemyName():
			self.LookForAnotherOpponent(EntityName)
		
	
	
	
	
	
	def StopNPCsAttacking (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			self.StopAttackingNPC (EntityName)
			if enemy and enemy.Life > 0 and enemy.Data.NPC:
				enemy.Data.StopAttackingNPC (enemy.Name)	
	

	def StopAttackingNPC (self,EntityName):
		if self.AttackingNPC:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life>0:
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy or enemy.Data.NPC:
					enemy = Bladex.GetEntity("Player1")
					if not enemy:
						print EntityName+": Cannot access handle to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return
					
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
					if me.SetEnemy(enemy):
						self.AttackingNPC=FALSE
						MaxCombatDist = Bladex.GetCharType(me.CharType,me.CharTypeExt).MaxCombatDist
						if me.SQDistance2(enemy) < (MaxCombatDist*MaxCombatDist) or me.CanISee(enemy):
							me.SetActiveEnemy(enemy)
							me.Chase(enemy, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)
						else:
							me.LaunchWatch()
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.LaunchAnmType("attack_look",1)
						self.CheckToJoin (EntityName)
					else:
						print EntityName+": Cannot SetEnemy to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return	


	def LaunchMyWatch(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life > 0:
			#possenemy=self.MyGetEnemyName()
			#if possenemy:
			#	enemy=Bladex.GetEntity(self.MyGetEnemyName())
			
			#if not enemy or not me.CanISee(enemy):
			#	me.StopLooking()
			#Just in case . This is the best place 4 this
			me.GoToJogging=0
			me.GoToSneaking=0
			me.LaunchWatch()

	
	def StdEndChase2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		# Check I'm not dead
		if me and me.Life > 0:
			Reference.debugprint(EntityName + ": I have ended a chase without combat (StdEndChase2)")
			me.RouteEndedFunc=self.StdRouteEnded
			me.StopLooking()
			self.InvestigatingSound = FALSE
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			if not enemy:
				return
			enemy_in_sight = enemy and me.CanISee(enemy)
			if enemy_in_sight and enemy.InsideActionArea(me.ActionAreaMax):
				if Actions.IsFacingEntity(EntityName, self.NameOfEnemy):
					self.LaunchMyWatch (EntityName)
				else:
					Actions.TurnToFaceEntity(EntityName, self.NameOfEnemy)
					me.RouteEndedFunc=self.LaunchMyWatch
			else:		
				if enemy_in_sight:
					self.StdSeeEnemyUnreachable (EntityName)
				else:
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					if me.GetActionMode() != Enm_Def.ROUTE_WATCH:
						self.LaunchMyWatch (EntityName)
					me.LaunchAnmType("look_around",1)
				# The enemy has disappeared for us around here
				# If we cannot find him, change our behaviour from the standard no seen function
				me.DelayNoSeenFunc=self.EndChaseDelayNoSeen
				if me.Data.imusic_noseen_warp==1:
					DMusic.RestoreMusicWarperDelayNoSeenFunc(EntityName)
								
						
	
	def StdStartChase2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		enemy=Bladex.GetEntity(self.MyGetEnemyName())
		
		oldActionMode = me.GetActionMode()		
		if (oldActionMode == Enm_Def.ROUTE_WATCH) or (oldActionMode == Enm_Def.ROUTE_BOWING):
			# We could have got here after turning, so reset the RouteEndedFunc.
			me.RouteEndedFunc=self.StdRouteEnded
		if oldActionMode == Enm_Def.ROUTE_CHASE:
			pass
		else:
			self.ResetCombat(EntityName)
			last_time_seen=me.LastTimeSeen       #Note that the "Chase" function updates the LastSeenTime!
			me.Chase(enemy, me.ActionAreaMax)
			if me.GetActionMode()==Enm_Def.ROUTE_CHASE:
				if self.IsArcher():
					self.Switch2MeleeWeapons(EntityName)
				else:
					if Bladex.GetTime()-last_time_seen>40 or last_time_seen<0:
						me.LaunchAnmType("alarm01",1)
					#else:
					#	print "Too early to alarm..." + str(me.LastTimeSeen)

				self.InvestigatingSound = FALSE
				me.RouteEndedFunc=self.StdEndChase 
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
			else:
				self.StdChaseFailed (EntityName, oldActionMode)
	
	
	def StdStartChase(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if not self.NameOfEnemy:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
		else:
			enemy=Bladex.GetEntity(self.NameOfEnemy)
		if not enemy:
			return
		me.AnmEndedFunc=self.StdAnmEnded
		if enemy.InsideActionArea(me.ActionAreaMax) or (self.IsArcher() and me.InsideActionArea(me.ActionAreaMax)):
			if not IsHoldingBow(enemy.Name):
				self.StdStartChase2 (EntityName)
				if self.NameOfEnemy:
					print EntityName+" I am chasing "+self.NameOfEnemy
		else:
			# The following is to turn to face the enemy when we are already at an illegal border
			self.StdSeeEnemyUnreachable (EntityName)	
		
		

	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
		Reference.debugprint(EntityName + ": Enemy Unreachable")
		
		if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP:
			return
		if me.InsideActionArea(me.ActionAreaMin) and (check1aaTo2aa and not me.Will1aaTo2aa):

			if me.Data.goto_limit2aa:
				back_area_min=me.ActionAreaMin
				back_area_max=me.ActionAreaMax
				me.ActionAreaMin=0
				me.ActionAreaMax=0
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy:
					return
				if enemy and IsHoldingBow(enemy.Name):
					print EntityName+" I am chasing an archer!!"
					return
				des_pos=enemy.Position
				me.GoToJogging=1
				if me.GoTo(des_pos[0],des_pos[1],des_pos[2]):
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
				else: 
					Reference.debugprint(EntityName + ": GoTo enemy_pos not working, with action area 0!")
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
			return

		elif me.InsideActionArea(me.ActionAreaMin):
			if me.GetActionMode() != Enm_Def.ROUTE_WATCH:
				self.LaunchMyWatch (EntityName)
			if not self.NameOfEnemy:
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
			else:
				enemy=Bladex.GetEntity(self.NameOfEnemy)
			if not enemy:
				return
			if not Actions.IsFacingEntity(EntityName, self.NameOfEnemy):
				Actions.TurnToFaceEntity(EntityName, self.NameOfEnemy)
			else:
				curr_time=Bladex.GetTime()
				if curr_time-self.last_insulting_time_1AA>4:
					insult_prob=whrandom.uniform(0.0, 1.0)
					if insult_prob<0.8:
						Combat.Insult(EntityName)
					insult_var=whrandom.uniform(-2.0, 1.0)
					self.last_insulting_time_1AA=Bladex.GetTime()+insult_var
		else:
			back_area_min=me.ActionAreaMin
			back_area_max=me.ActionAreaMax
			me.ActionAreaMax= 0
			me.ActionAreaMin= 0
			
			init_pos=me.InitPos
			me.InvertedRoute=1 # Move backwards
			if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
			else:
				Reference.debugprint(EntityName + ": GoTo init_pos not working, with action area 0!")
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
		
		
		

	def StdChaseFailed(self,EntityName, oldActionMode):	# Try to restore our state to whatever we were doing before attempting to chase	
		me = Bladex.GetEntity(EntityName)
		newActionMode = me.GetActionMode()
		if newActionMode == Enm_Def.ROUTE_BOWING:
			Reference.debugprint(EntityName + ": I cannot start a chase so I will bow")	
			pass
		#NOTA : R_WATCH incluye _BAY (al fallar un GoTo desde una W_BAY se pasa AUTOMATICAMEnTE a watch!!!)
		elif oldActionMode == Enm_Def.ROUTE_WATCH:
			Reference.debugprint(EntityName + ": I cannot start a chase so I will watch again")
			self.LaunchMyWatch(EntityName)

			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			
			if enemy and me.CanISee(enemy) and me.InsideActionArea(me.ActionAreaMin):
				inv = me.GetInventory()
				if inv.HasBow and me.RangeActive:
					#print "StdChaseFailed-> Just facing due to carry bow"
					enemy_pos=me.EnemyLastSeen
					if not Actions.IsFacingPos(EntityName, enemy_pos[0], enemy_pos[2]):
						Actions.TurnToFacePos(EntityName, enemy_pos[0], enemy_pos[2])
				else:
					self.StdSeeEnemyUnreachable (EntityName,0)



	def StdHearFunc(self,EntityName, SoundName, x, y, z, Volume):
		me = Bladex.GetEntity(EntityName)
		if me and Bladex.InsideActionArea(me.ActionAreaMax, x , y , z)==0:
			return
		if me and me.Life > 0 and me.Deaf<>1:
			# Is the sound below audible range
			if Volume < Bladex.GetCharType(me.CharType,me.CharTypeExt).HearMinVolume:
				return
			# No need to bother responding if we're already in combat
			if me.InCombat:
				return
			sound_type= self.GetSoundType(SoundName)
			# Is the sound unknown
			if sound_type==Reference.SND_UNCLASSIFIED:
				return
			# If our enemy is dead, don't bother going to investigate
			if self.NameOfEnemy:
				enemy=Bladex.GetEntity(self.NameOfEnemy)
			else:
				if self.MyGetEnemyName()!= None:
					enemy=Bladex.GetEntity(self.MyGetEnemyName())
				else:
					return
			
			if (not enemy) or (not enemy.Person) or enemy.Life <= 0:
					return
					
			# for footsteps etc, Check they belong to the player, not realistic, but quick
			if sound_type==Reference.SND_NOISYPC:
				if enemy.LastSound != SoundName:
					return
					
				elsp= enemy.LastSoundPosition
				if elsp[0]!= x or elsp[1]!=y or elsp[2]!=z:
					return
				
			# Was the sound generated by oureself
				
			if me.LastSound==SoundName:
				lsp= me.LastSoundPosition
				if lsp[0]== x and lsp[1]==y and lsp[2]==z:
					return
				
			# Is the sound from our last thrown hurt ?
			if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP*0.5:
				return	
				
			# The see functions will take care of this
			if me.CanISee(enemy):
				return
			if self.Asleep:
				self.WakeMeUp(EntityName)

			if me.GetActionMode() == Enm_Def.ROUTE_BAY and not me.CanGoTo(x,y,z):
				return 
			if self.group_leader:
				# record that we have dealt with the sound
				self.DealtWithSound= SoundName
				self.DealtWithSoundX= x
				self.DealtWithSoundY= y
				self.DealtWithSoundZ= z
					
				# Assign an investigator
				investigator = self.GetGroupFighter(EntityName)
				if (not investigator) or (investigator.Name != me.Name):
					if (not investigator) or investigator.GetActionMode()==Enm_Def.ROUTE_CHASE or investigator.InCombat or not investigator.CanGoTo(x,y,z):
						investigator = me
			else:
				group_leader = self.GetGroupLeader(EntityName)
				if group_leader and not (group_leader.InCombat or group_leader.GetActionMode()==Enm_Def.ROUTE_CHASE):
					# does the leader know already?
					try:
						ldr_data= group_leader.Data
						if SoundName==ldr_data.DealtWithSound and x==ldr_data.DealtWithSoundX and y==ldr_data.DealtWithSoundY and z==ldr_data.DealtWithSoundZ:
							return
					except:
						pass
					group_leader.HearFunc(group_leader.Name, SoundName, x, y, z, Volume)
					# leader will tell investigator what to do
					# but we can take the initiative to turn around
					if (not me.InCombat) and (me.GetActionMode()!=Enm_Def.ROUTE_CHASE):
						if not Actions.IsFacingPos(EntityName, x, z):
							Actions.QuickTurnToFacePos(EntityName, x, z)
					return
				else:
					# leader is busy, investigate ourself
					investigator = me
	
			if investigator.Data.InvestigatingSound and SoundName == investigator.Data.InvestigatingSoundName and x == investigator.Data.InvestigatingSoundX and y == investigator.Data.InvestigatingSoundY and z == investigator.Data.InvestigatingSoundZ:
				# investigator is already investigating this sound		
				return 
			elif investigator.Data.IsSoundHigherPriority(investigator.Name, SoundName, Volume) and investigator.GetActionMode()!=Enm_Def.ROUTE_CHASE and not investigator.InCombat:
				me.StartLooking(x, y, z)
	
				# Turn to face the sound
				if not Actions.IsFacingPos(EntityName, x, z):
					Actions.QuickTurnToFacePos(EntityName, x, z)

				# React to the sound, with alarm
				if investigator.Name != EntityName: 
					# Tell investigator to turn to face the sound
					if not Actions.IsFacingPos(investigator.Name, x, z):
						Actions.QuickTurnToFacePos(investigator.Name, x, z)
						
					if (not investigator.Data.InvestigatingSound):
						if (me.AnimName[:4] != "hurt" and me.AnimName[:5] != "sleep"):
							if investigator.Data.CanGoTo(investigator.Name, x, y, z):
								me.Wuea=Reference.WUEA_ENDED
								me.SetTmpAnmFlags(1,0,1,0,1,1) 
								me.LaunchAnmType("alarm01",1)
	
				# Send off fighter to investigate
				investigator.Data.InvestigatingSound = TRUE
				investigator.Data.InvestigatingSoundName = SoundName
				investigator.Data.InvestigatingSoundVolume = Volume
				investigator.Data.InvestigatingSoundX = x
				investigator.Data.InvestigatingSoundY = y
				investigator.Data.InvestigatingSoundZ = z
	
				if me.AnimName=="alarm01":
					if EntityName != investigator.Name:
						self.NextOrdersTo = []
						self.NextOrdersTo.append(investigator.Name)
						self.NextOrders = investigator.Data.StdInvestigateSound
						me.AnmEndedFunc=self.GiveOrders
					else:
						me.AnmEndedFunc=self.StdInvestigateSound
				else:
					if EntityName != investigator.Name:
						self.NextOrdersTo = []
						self.NextOrdersTo.append(investigator.Name)
						self.NextOrders = investigator.Data.StdInvestigateSound
						self.GiveOrders (EntityName)
					else:
						self.StdInvestigateSound (EntityName)

	
	
	def StdEnemyNoAllowedArea(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		enemy=Bladex.GetEntity(self.MyGetEnemyName())
		
		if me.GetActionMode()<>Enm_Def.ROUTE_CHASE:
			return
		init_pos=me.InitPos
		if (not me.InsideActionArea(me.ActionAreaMin)) and me.InsideActionArea(me.ActionAreaMax):
			me.InvertedRoute=1
		else:
			me.InvertedRoute=0
		me.GoTo(init_pos[0],init_pos[1],init_pos[2])####################### do I want this???
		Reference.debugprint(EntityName + ": My enemy has entered a non-allowed area")
	
	
	
	def CheckGoodGroupFormation(self,EntityName, include_me):
		me = Bladex.GetEntity(EntityName)

		if me.CombatGroup:
			memberlist = me.GetGroupMembers()
			if len(memberlist) > 1:
				fighter_found = None
				leader_found = None
				
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				
				if not enemy:
					return
				for member_name in memberlist:
					if include_me or member_name != EntityName:
						member = Bladex.GetEntity (member_name)

						if (not leader_found) and member and member.Data.group_leader and member.Life > 0:
							if (not member.Data.group_fighter) and (not member.Data.Furious):
								member.CombatDistFlag = 1
							leader_found = member.Name
						else:
							member.Data.group_leader = FALSE

						if (not fighter_found) and member and member.Data.group_fighter and member.Life > 0 and enemy and member.CanISee(enemy):
							member.CombatDistFlag = 0
							fighter_found = member.Name
						else:
							if member.Data.group_fighter:
								if not member.Data.Furious:
									member.CombatDistFlag = 1
								member.Data.group_fighter = FALSE

				if fighter_found and leader_found and (fighter_found != leader_found):
					return

				# If we get to this point then we're either missing a group leader or a group fighter
				self.SetGroupFormation (EntityName, include_me, not leader_found)
	
			else:
				if include_me:
					self.group_leader= TRUE
					self.group_fighter= TRUE
					me.CombatDistFlag= 0
				return	
	

	def Respond2Thrown(self, EntityName, AttackerName):
		me = Bladex.GetEntity(EntityName)
		if self.Asleep:
			self.WakeMeUp(EntityName)
		if AttackerName:
			enemy=Bladex.GetEntity(self.MyGetEnemyName())
			if enemy and not enemy.InsideActionArea(me.ActionAreaMax):
				self.LastThrownHurtTime=Bladex.GetTime()
				init_pos=me.InitPos
				me.InvertedRoute=0 #Just in case
				me.GoToJogging=1
				if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
					me.RouteEndedFunc= self.Turn180AndWatch
			else:
				if me.GetActionMode() == Enm_Def.ROUTE_WATCH:
					#print "FIX?"
					Actions.QuickTurnToFaceEntity(EntityName,AttackerName)
				else:
					print "Respond2Thrown->Bug?"
	

	def Switch2MeleeWeapons(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life > 0 and not me.RangeActive:
			inv= me.GetInventory()
			right_type= Reference.GiveObjectFlag(me.InvRight)
						
			# Do we have an item in the hand we can fight with			
			if inv.HoldingBow or not (right_type== Reference.OBJ_STANDARD or right_type== Reference.OBJ_WEAPON):
				# Don't change if the enemy is unreachable
				enemy=Bladex.GetEntity(self.MyGetEnemyName())
				if me.AstarState!=Enm_Def.ASTAR_NOSOLVED:
					me.SwitchTo1H()
					weapon_name= inv.GetSelectedWeapon()
					if weapon_name and (weapon_name != me.InvRight and weapon_name != me.InvLeft):
						# Launch the swap weapons animation
						out= ScorerActions.CB_WeaponOutX(EntityName,0)
						if not out:
							me.AnmEndedFunc= ScorerActions.CB_WeaponOutX
						Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, self.Switch2MeleeWeapons,(EntityName,),EntityName+"ReSwitch2MeleeWeapons")
					Actions.EndBowMode(EntityName)


	
	def OnKilledEnemy(self,KilledEntityName):
		print "Enemy Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			print "Levelup PS params set"
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			
						

			
				
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.NameOfEnemy or Bladex.GetEntity(self.NameOfEnemy).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		char=Bladex.GetEntity("Player1")
                   		if me.CanISee(char):
	  				self.NameOfEnemy="Player1"
                   			enemy=Bladex.GetEntity(self.NameOfEnemy)
                			me.SetEnemy(enemy)
					return self.NameOfEnemy			
                   		else:
                   			return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.NameOfEnemy=enemyList[0]
		enemy=Bladex.GetEntity(self.NameOfEnemy)
                me.SetEnemy(enemy)
		return self.NameOfEnemy			
				
				
		
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Alpha<0.9:
			return FALSE
		if entity.Kind=="LookoutMan":
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		if IsHoldingBow(entity.Name):
			return FALSE
		if  CheckIfEnemy(entity.Name): 
			return TRUE
		else:
			return FALSE
			

	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)
		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER


	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			Reference.debugprint (EntityName + ": I spy a GOOD guy")
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					Reference.debugprint (EntityName + ": Your Name is "+ene.Name+ " I will do you over")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Enm_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Enm_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==Enm_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							#print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()




					
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				#####################################################################
				# consider getting furious
				chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)
				# consider attacking attacker back
				#damage_factor = DamagePoints / (me.Life+DamagePoints)
				#if damage_factor > me.Data.DamageFactorNone:
				#	# Only if I'm still alive... Death events handled apart
				####################################################################
				#Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
					
				if self.NameOfEnemy and self.NameOfEnemy != AttackerName:
					#Reference.debugprint(AttackerName+": Is NOT my current enemy")
					attacker = Bladex.GetEntity(AttackerName)
					##########################################
					if IsHoldingBow(AttackerName):
						print EntityName+" My Enemy is an Archer"
						return
					
					if attacker and (self.AttacksOwnKind or attacker.Kind != me.Kind):
						
						Reference.debugprint(EntityName+": I will respond")
						# Only attack NPCs if not already, otherwise we get multiple scheduled funcs
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							#Reference.debugprint("attacker.Data.NPC: "+ `attacker.Data.NPC`+ ", self.AttackingNPC: " + `self.AttackingNPC`)
								
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		
	
				
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if (not self.Asleep) and (not me.Blind):
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
				me.StopLooking()
				self.PutMeToSleep(EntityName)
				if not self.NameOfEnemy:
					self.LookForAnotherOpponent(EntityName)
				Reference.debugprint(EntityName+": I have got bored and dropped to sleep")
				
							
				
				
	def LookForAnotherOpponent(self,EntityName):
		Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		mep=me.Position
		enelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 30000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					enelist.append(en.Name)
		if len (enelist) == 0: 
                   	return 
                enelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(enelist[0])
                if nearest:
			me.GoToJogging=0
			me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
			if me.AstarState==Enm_Def.ASTAR_SOLVED:
				me.LaunchWatch()
			print EntityName+" I have found a new enemy and I am going to sort the bugger out "
					
                    				
		       			

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttackNPCTime = 100
	
	
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			me.Deaf=1
			self.Asleep = TRUE


	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			me.Deaf=0
			self.Asleep = FALSE
			
		
				
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["EnemyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
		                                 self.DeathArgs,
		                                 GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                 self.LevelupArgs,
		                                 self.NameOfEnemy,
						 self.Dusted)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["EnemyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			self.DeathArgs=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"LevelupFunc")
			self.LevelupArgs=parms[3]
			self.NameOfEnemy=parms[4]
			self.Dusted=parms[5]
			
		self.NPCLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
		Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
		me=Bladex.GetEntity(self.Name)
		
				
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		me.ImDeadFunc=self.NewImDeadFunc
		
		
##########################################################################################################################################################
######## Race Sub-Classes #####


class EnemyKnight_Traitor (EnemyChar):
	def __init__(self, me):
		
		EnemyChar.__init__(self, me)
		

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Knight_Traitor":
			AniSound.AsignarSonidosCaballeroTraidor(EntityName)
		elif me.Kind=="Dark_Knight":
			AniSound.AsignarSonidosCaballeroOscuro(EntityName)




	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["EnemyKnight_Traitor"]=()
		return NPCPerson_state
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["EnemyKnight_Traitor"]
			

	def ResetCombat (self,EntityName):		
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100
			me.BlockingPropensity = 0.7
			me.AttackList = BCopy.deepcopy(Combat.TraitorKnightAttackData)
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			
			
				
#########################################################################################################################################################	


class DorcasEvil (EnemyChar):

	RightWeapon=""
	LeftWeapon=""
	LeftWeaponEdge=""
	WeaponsStowed=0

	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		me.AddAnmEventFunc("StartL_Weapon",self.StartLWepDamage)
		me.AddAnmEventFunc("StopL_Weapon",self.StopLWepDamage)	
		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25		
		
		me.MeshName="Fem1Wiz_Evil"
		
		self.AttachLHEdge()
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		import AniSoundDorcas
		AniSoundDorcas.AsignarSonidosDorcas(EntityName)
		if me.MeshName=="Fem1Wiz_Evil":
			Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUDorcasStuff/DorcasEvilIcon.bmp","DorcasEvilIcon")
			Reference.EnemiesScorerData[self.Name]=("DorcasEvilIcon","Dor")	
		else:
			Bladex.ReadBitMap("../../Maps/DwarfWars/NUFiles/NUFemaleStuff/DorcasIcon.bmp","DorcasIcon")
			Reference.EnemiesScorerData[self.Name]=("DorcasIcon","Dor")	
		
		
	
	
	def ResetCombat (self,EntityName):		
		EnemyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 1.5
			
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			rwp=me.InvRight
			if rwp:
				inv= me.GetInventory()
				if inv.HoldingShield: 
					me.BlockingPropensity = 1.0
					me.RangeDefenceCapable = TRUE
					print"I have a shield"
				else: 
					me.BlockingPropensity = 0.0
					me.RangeDefenceCapable = FALSE
					
				if Bladex.GetEntity(rwp).Kind==("ProRHWep2","ProRHWep3","ProRHWep4"):
					me.AttackList = BCopy.deepcopy(DorcasEvilTwinHandedAttackData)
					return
						
				flag=Reference.GiveWeaponFlag(rwp)
				if flag==Reference.W_FLAG_1H:
					me.AttackList = BCopy.deepcopy(DorcasEvil1HAttackData)
				if flag==Reference.W_FLAG_2W:
					me.AttackList = BCopy.deepcopy(DorcasEvil2HAttackData)
				if flag==Reference.W_FLAG_SP:
					me.AttackList = BCopy.deepcopy(DorcasEvilSPAttackData)
			else:
				me.AttackList = BCopy.deepcopy(DorcasEvilOnarmedAttackData)
				
			
			
	def StdEnterClose(self,EntityName):
		Enm_Def.NPCPerson.StdEnterClose(self,EntityName)
		self.DrawWeapons(EntityName)
			
					
		
	def StowWeapons(self, EntityName):
		if self.WeaponsStowed==0:
			me = Bladex.GetEntity(EntityName)
			inv=me.GetInventory()
			Actions.StdToggleWeapons(EntityName)
			self.WeaponsStowed=1
			print "DorcasEvil stowing weapons"
			
		
	def DrawWeapons(self, EntityName):
		if self.WeaponsStowed==1:
			me = Bladex.GetEntity(EntityName)
			inv=me.GetInventory()
			Actions.StdToggleWeapons(EntityName)
			self.WeaponsStowed=0
			print "DorcasEvil drawing weapons"
		
		
	def WakeMeUp(self,EntityName):
		Reference.debugprint(EntityName+": I am waking up")
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE	
			if self.WeaponsStowed and not AmIArmed(EntityName):
				self.DrawWeapons(EntityName)
				
				
	def PutMeToSleep(self,EntityName):
		Reference.debugprint(EntityName+": I am going to sleep")
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE
			if self.WeaponsStowed==0 and not me.InCombat:
				self.StowWeapons(EntityName)
				#self.LookAround90(EntityName)
				Reference.debugprint(EntityName+": I am not busy so I will sheathe my weapon")
		
		

	def AttachLHEdge(self):
		me = Bladex.GetEntity(self.Name)
		dedge=Bladex.CreateEntity(self.Name+"DummyEdge","ProLHWep2Edge",58700.0,-960.0,380.0, "Weapon")
		dedge.Alpha=0.0
		dedge.RasterMode="Read"
		dedge.RasterMode="AdditiveAlpha"
		dedge.CastShadows=0
		# Fem1Wiz -Dorcas - has extra Anchor in mesh -Blade_Anchor_21
		me.LinkAnchors("21",dedge,"1H_R")
		self.LeftWeaponEdge=dedge.Name
		


	def StartLWepDamage(self, EntityName, EventName):
		ledge=Bladex.GetEntity(self.LeftWeaponEdge)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		
		
	def StopLWepDamage(self, EntityName, EventName):
		ledge=Bladex.GetEntity(self.LeftWeaponEdge)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.StopLAfterInterupt,())



	def StopLAfterInterupt(self):
		print "Damage OFF again"
		ledge=Bladex.GetEntity(self.LeftWeaponEdge)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)



	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["DorcasEvil"]=(self.RightWeapon,self.LeftWeapon,self.LeftWeaponEdge,self.WeaponsStowed)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["DorcasEvil"]
			self.RightWeapon=parms[0]
			self.LeftWeapon=parms[1]
			self.LeftWeaponEdge=parms[2]
			self.WeaponsStowed=parms[3]
			me.AddAnmEventFunc("StartL_Weapon",self.StartLWepDamage)
			me.AddAnmEventFunc("StopL_Weapon",self.StopLWepDamage)		


			
DorcasEvil1HAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.ATTACK, 0.30,("GM1_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.20,("GM2_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.15,("GM3_1H",),500.0, 1800.0, 2500.0, 0.35],             
	    [Combat.ATTACK, 0.20,("GM4_1H",),500.0, 1800.0, 2500.0, 0.35],             
	    [Combat.ATTACK, 0.05,("GI_1H",), 500.0, 1800.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.15,("GM23_1H",),500.0, 1200.0, 2200.0, 0.35],             
            [Combat.MOVE,   0.05, Combat.TempMoveInProc,3000.0,  7000.0, 9000.0, 0.35, 1],
            
           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]	


DorcasEvil2HAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.ATTACK, 0.15,("GI_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.15,("GM4_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.15,("GM2_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [Combat.ATTACK, 0.10,("GM3_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [Combat.ATTACK, 0.15,("GM1_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.15,("GM23_2H",),500.0, 1000.0, 2800.0, 0.35],    
            [Combat.ATTACK, 0.12,("GM1_2H","GM9_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [Combat.ATTACK, 0.12,("GM2_2H","GM10_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [Combat.ATTACK, 0.05,("GM3_2H","GM8_2H",),500.0, 1000.0, 2800.0, 0.35],   
	    [Combat.ATTACK, 0.12,("GM4_2H","GM11_2H",),500.0, 1000.0, 2800.0, 0.35], 
	    [Combat.ATTACK, 0.05,("GI_2H","GM12_2H",),500.0, 1000.0, 2800.0, 0.35], 
	    [Combat.MOVE,   0.05, Combat.TempMoveInProc,3000.0,  7000.0, 9000.0, 0.35, 1],
					
            
           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]			



DorcasEvilSPAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.ATTACK, 0.8, ("GM15_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.8, ("GM10_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.05, ("GI_SP",) ,1200.0, 1800.0, 2500.0, 0.35], 
	    [Combat.ATTACK, 0.05, ("GMI_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [Combat.ATTACK, 0.05, ("GM8_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [Combat.ATTACK, 0.05, ("GM6_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [Combat.ATTACK, 0.05, ("GM3_SP",),1200.0, 1800.0, 2500.0, 0.35], 
					
            
           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]	


DorcasEvilUnarmedAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.ATTACK, 0.8, ("GM21_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [Combat.ATTACK, 0.8, ("GM22_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [Combat.ATTACK, 0.8, ("GM23_NO",),500.0, 1000.0, 1500.0, 0.35],
					
            
           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]					


DorcasEvilTwinHandedAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[Combat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	    [Combat.ATTACK, 0.12,("GM1_1H",),500.0, 1000.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.12,("GM2_1H",),500.0, 1000.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.12,("GM3_1H",),500.0, 1000.0, 2500.0, 0.35],             
	    [Combat.ATTACK, 0.12,("GM4_1H",),500.0, 1000.0, 2500.0, 0.35],             
	    [Combat.ATTACK, 0.15,("GI_1H",), 500.0, 1200.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.12,("GM1_1H","GM38_1H",),500.0, 1200.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.12,("GM2_1H","GM5_1H",) ,500.0, 1200.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.12,("GM3_1H","GM35_1H",),500.0, 1200.0, 2500.0, 0.35],            
            [Combat.ATTACK, 0.12,("GM4_1H","GM39_1H",),500.0, 1200.0, 2500.0, 0.35],            
            [Combat.DODGE, 0.08, ("DR","DR_G_1H",),900.0, 1200.0, 2200.0, 0.35],
            [Combat.DODGE, 0.08, ("DL","DL_G_1H",),900.0, 1200.0, 2300.0, 0.35],  
	    [Combat.ATTACK, 0.05,("GM88_1H",),500.0, 1500.0, 2800.0, 0.35],	
	    [Combat.ATTACK, 0.05,("GM95_1H",),500.0, 1500.0, 2800.0, 0.35],	
	    [Combat.ATTACK, 0.05,("GM91_1H",),500.0, 1500.0, 2800.0, 0.35],	
	    [Combat.ATTACK, 0.05,("GM96_1H",),500.0, 1500.0, 2800.0, 0.35],
	    [Combat.ATTACK, 0.05,("GM99_1H",),800.0, 1500.0, 2800.0, 0.35],	
	    [Combat.ATTACK, 0.05,("GM90_1H",),800.0, 1500.0, 2800.0, 0.35],
            
           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]					



##########################################################################################################################################################
######### Reptilian type

class Haedraline (EnemyChar):
	def __init__(self, me):	
		EnemyChar.__init__(self, me)
	
		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		
		me.ImDeadFunc=self.NUImDeadFunc
		
		if me.Kind[:5]=="Morag":
			self.MakeMeAShield()
				


	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		
		if me.Kind[:5]=="Morag":
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUHaedralineStuff/MoragAIcon.bmp","MoragAIcon")
			Reference.EnemiesScorerData[self.Name]=("MoragAIcon","Mrg")
			AniSoundMorag.AsignarSonidosMorag(EntityName)
		else:
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUHaedralineStuff/HaedralineAIcon.bmp","HaedralineAIcon")
			Reference.EnemiesScorerData[self.Name]=("HaedralineAIcon","Hdr")
			AniSoundHaedraline.AsignarSonidosHaedraline(EntityName)
		
		
		
	def NUImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		if me.InvLeft and me.Kind[:5]=="Morag":
			sh=Bladex.GetEntity(me.InvLeft)
			Actions.RemoveFromInventory(me, sh, "DropLeftEvent")
			sh.Alpha=0.0
			sh.Position=0,50000,0
			print"Morag Slain"
		EnemyChar.NewImDeadFunc(self,EntityName)
		
		
		
		
	def MakeMeAShield(self):
		me = Bladex.GetEntity(self.Name)
		if me.InvLeft:
			return
		sh=Bladex.CreateEntity(self.Name+"SH","DalShield",0,0,0,"Weapon")
		Sparks.MakeShield(sh.Name)
		sh.Alpha=0.0
		sh.CastShadows=0
		sh.RasterMode="Read"
		Actions.TakeObject(self.Name,sh.Name)
		
		

	def ResetCombat (self,EntityName):
		EnemyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			me.BlockingPropensity = 0.6
			flag=GiveWeaponType(EntityName)
			if flag==W_FLAG_1H:
				me.AttackList = BCopy.deepcopy(Haedraline1HAttackData)
				
				
			## They will handle 2H Swords and Axes......
				
			"""
			elif flag==W_FLAG_2W:
				me.AttackList.append ([Combat.ATTACK, 0.50, ("GI_2H",), 1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.40, ("GM1_2H",),1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.25, ("GM10_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
	    			me.AttackList.append ([Combat.ATTACK, 0.25, ("GM7_2H",),1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.10, ("GM4_2H",),1500.0, 2500.0, 3500.0, 0.35],) 
			
				if me.Level>1:
					me.AttackList.append ([Combat.DODGE, 0.02, ("D_r","DR_G_2H",),1200.0, 1600.0, 2500.0, 0.35],)
					me.AttackList.append ([Combat.DODGE, 0.02, ("D_l","DL_G_2H",),1200.0, 1600.0, 2500.0, 0.35],)  
				if me.Level>2:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM4_2H","GM5_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>3:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM7_2H","GM8_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM10_2H","GM11_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([Combat.ATTACK, 0.02, ("GM1_2H","GM6_2H",),1200.0, 1600.0, 2500.0, 0.35],)  # ChaosSword
				if me.Level>5:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM1_2H","GM12_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>7:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM7_2H","GM41_2H",),1200.0, 1600.0, 2500.0, 0.35],) # DeathSword
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM1_2H","GM2_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>9:
					me.AttackList.append ([Combat.ATTACK, 0.02, ("GM11_2H","GM15_2H",),1200.0, 1600.0, 2500.0, 0.35],) # SlayingSword
				if me.Level>11:
					me.AttackList.append ([Combat.ATTACK, 0.09, ("GI_2H","GM23_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
					me.AttackList.append ([Combat.ATTACK, 0.09, ("GI_2H","GM42_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>14:
					me.AttackList.append ([Combat.ATTACK, 0.02, ("GI_2H","GM23_2H","GM24_2H",),1500.0, 2000.0, 2500.0, 0.35],) 
				if me.Level>18:
					me.AttackList.append ([Combat.ATTACK, 0.09, ("GM1_2H","GM40_2H",),1200.0, 1600.0, 2500.0, 0.35],) 
			
			elif flag==W_FLAG_AXE:
				me.AttackList.append ([Combat.ATTACK, 0.50, ("GI_AXE",), 1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.40, ("GM17_AXE",),1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.25, ("GM19_AXE",),1500.0, 2500.0, 3500.0, 0.35],) 
	    			me.AttackList.append ([Combat.ATTACK, 0.25, ("GM21_AXE",),1500.0, 2500.0, 3500.0, 0.35],)
	    			me.AttackList.append ([Combat.ATTACK, 0.10, ("GM28_AXE",),1500.0, 2500.0, 3500.0, 0.35],) 
			
				if me.Level>1:
					me.AttackList.append ([Combat.DODGE, 0.02, ("D_r","DR_G_AXE",),1200.0, 1600.0, 2500.0, 0.35],)
					me.AttackList.append ([Combat.DODGE, 0.02, ("D_l","DL_G_AXE",),1200.0, 1600.0, 2500.0, 0.35],)  
				if me.Level>2:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM28_AXE","GM29_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>5:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM19_AXE","GM32_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>9:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM21_AXE","GM26_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>10:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM17_AXE","GM31_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
				if me.Level>14:
					me.AttackList.append ([Combat.ATTACK, 0.05, ("GM19_AXE","GM27_AXE",),1200.0, 1600.0, 2500.0, 0.35],) 
			else:
				pass
			"""


				
				
				
				

Haedraline1HAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],

           # dodges:
            [Combat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.40, "d_b",                500.0, 1200.0, 2800.0, 0.35],

            
            [Combat.ATTACK, 1.00, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],

	    [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [Combat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [Combat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            
            [Combat.ATTACK, 0.50, ("GI_1H",), 1000.0, 1500.0, 2500.0, 0.35],
	    [Combat.ATTACK, 0.12, ("GM1_1H",),1000.0, 1500.0, 3000.0, 0.35],
	    [Combat.ATTACK, 0.12, ("GM2_1H",),1000.0, 1500.0, 3000.0, 0.35],
	    [Combat.ATTACK, 0.12, ("GM3_1H",),1000.0, 1500.0, 3000.0, 0.35],
	    [Combat.ATTACK, 0.12, ("GM4_1H",),1000.0, 1500.0, 3000.0, 0.35],
	    [Combat.ATTACK, 0.12, ("GM53_1H",),1200.0, 1800.0, 3000.0, 0.35],
            
            [Combat.MOVE,   0.80,  KeepDistance,       2800.0, 6250.0, 9500.0, 0.35,1],
            #[Combat.MOVE,   0.06, Combat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35],
            

]

##########################################################################################################################################################
########### Goblins


class Goblin (EnemyChar):
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSoundGoblin.AsignarSonidosGoblin(EntityName)
		if me.MeshName=="Goblin_B":
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUGoblinStuff/Goblin_BIcon.bmp","GoblinBIcon")
			Reference.EnemiesScorerData[self.Name]=("GoblinBIcon","Gob")
		else:
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUGoblinStuff/Goblin_AIcon.bmp","GoblinIcon")
			Reference.EnemiesScorerData[self.Name]=("GoblinIcon","Gob")


	def ResetCombat (self,EntityName):
		EnemyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.AttackList = BCopy.deepcopy(GoblinAttackData)
			me.BlockingPropensity = 0.5
			self.ChanceOfFuryOnHurt = 0.45	
			



#### 


class GoblinArcher (EnemyChar):

	Agenum=0
	
	def __init__(self, me):
		EnemyChar.__init__(self, me)
		
		# Set up orc specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		self.Agenum=0
		self.ToolUp()
		
	# Create Kit and set mesh with bag of rocks
		
	def ToolUp(self):
		me=Bladex.GetEntity(self.Name)
		me.SetMesh("Goblin_Archer")
		inv=me.GetInventory()
		bw=Bladex.CreateEntity(self.Name+"BW","GoblinCatapult",0,0,0,"Weapon")
		bw.Data=GoblinWeaponTypes.GoblinCatapult(bw)
		qv=Bladex.CreateEntity(self.Name+"QV","GoblinQuiver",0,0,0,"Weapon")
		qv.Data=GoblinWeaponTypes.GoblinQuiver(qv)
		inv.AddBow(bw.Name)
		inv.AddQuiver(qv.Name)
		
		
		
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="Goblin_A":
			AniSoundGoblin.AsignarSonidosGoblin(EntityName)
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUGoblinStuff/Goblin_AIcon.bmp","GoblinIcon")
			Reference.EnemiesScorerData[self.Name]=("GoblinIcon","Gob")
		else:
			AniSoundGoblin.AsignarSonidosGoblin(EntityName)
			Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NUGoblinStuff/Goblin_AIcon.bmp","GoblinIcon")
			Reference.EnemiesScorerData[self.Name]=("GoblinIcon","Gob")



	def ResetCombat (self,EntityName):
		EnemyChar.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.AttackList = BCopy.deepcopy(GoblinAttackData)
			me.BlockingPropensity = 0.5
			self.ChanceOfFuryOnHurt = 0.45	



	def RockStopFunc(self,EntityName):
		object= Bladex.GetEntity(EntityName)
		if object:
			object.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			object.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			if object.Kind=="FlechaGoblin":
				object.SubscribeToList("Pin")



	def CreateAndFireRock(self, CatapultName):
		me=Bladex.GetEntity(self.Name)
		cat = Bladex.GetEntity(CatapultName)
		if not cat:
			print "No Catapult"
			return
		x,y,z=cat.GraspPos("Rock")
		rock=Bladex.CreateEntity(self.Name+"Rock"+`self.Agenum`,"FlechaGoblin",x,y,z,"Weapon")
		vx,vy,vz=me.AimVector
		vxp=vx*7
		vyp=vy*7
		vzp=vz*7
		rock.Impulse(vxp,vyp,vzp)
		rock.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		rock.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
		InitDataField.Initialise(rock)
		rock.OnStopFunc=self.RockStopFunc
		rock.Data.PrevInflictHitFunc= rock.InflictHitFunc
		rock.InflictHitFunc= Actions.ThrownWeaponInflictHitFunc
		rock.Data.ThrownBy= me
		print "GoblinRockGone"



	def __getstate__(self):	
		NPCPerson_state=EnemyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["GoblinArcher"]=(self.Agenum,)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["GoblinArcher"]
			self.Agenum=parms[0]
			





GoblinAttackData =	[ 
           # inner zone blocks:
            [Combat.BLOCK,  0.25, (),                   500.0, 1000.0, 3000.0, 0.50],
            [Combat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.05, "tf",                 750.0, 1500.0, 3500.0, 0.50],
           # total inner zone 0.45
           
           # outer zone blocks:
            [Combat.BLOCK,  0.07, (),                  3000.0, 4000.0, 5000.0, 0.50],
            [Combat.BLOCK,  0.035,"tr",                3500.0, 7000.0, 9000.0, 0.50,1],
            [Combat.BLOCK,  0.035,"tl",                3500.0, 7000.0, 9000.0, 0.50,1],
            [Combat.BLOCK,  0.245,"tb",                3500.0, 7000.0, 9000.0, 0.50,1],
            [Combat.BLOCK,  0.07, "tf",                3500.0, 7000.0, 9000.0, 0.50,1],
           # total outer zone 0.455
           
           # dodges:
            [Combat.DODGE,  0.30, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.30, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [Combat.DODGE,  0.30, "d_b",                500.0, 1200.0, 2800.0, 0.35],

           # attacks:
            [Combat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1800.0, 2500.0, 0.35],

            [Combat.ATTACK, 0.50, ("g_01",),            765.0, 2397.5, 3265.0, 0.35],
            [Combat.ATTACK, 0.40, ("g_02",),            873.0, 2123.0, 3373.0, 0.35],
            [Combat.ATTACK, 0.40, ("g_06",),            764.0, 2014.0, 3264.0, 0.35],
            [Combat.ATTACK, 0.20, ("g_15",),            844.0, 2094.0, 3344.0, 0.35],
            [Combat.ATTACK, 0.20, ("g_16",),            243.0, 1493.0, 2743.0, 0.35],
            [Combat.ATTACK, 0.15, ("g_18",),           1917.0, 3167.0, 4417.0, 0.35],
            [Combat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1200.0, 1.00,1],
            
            # combinations
            [Combat.ATTACK, 0.40, ("COMBO1",),            764.0, 2014.0, 3264.0, 0.35],
            [Combat.ATTACK, 0.40, ("COMBO2",),            243.0, 1493.0, 2743.0, 0.35],
            [Combat.ATTACK, 0.40, ("COMBO3",),            873.0, 2123.0, 3000.0, 0.35],

           # inner zone moves:
            [Combat.MOVE,   0.03, "tr",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.03, "tl",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.05, "tb",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.10, "tf",                   0.0, 2000.0, 5000.0, 0.50],

           # outer zone moves:
            [Combat.MOVE,   0.03, "tr",                5000.0, 7000.0, 9000.0, 0.50,1],
            [Combat.MOVE,   0.03, "tl",                5000.0, 7000.0, 9000.0, 0.50,1],
            [Combat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50,1],
            [Combat.MOVE,   0.03, "tf",                5000.0, 7000.0, 9000.0, 0.50,1],
            [Combat.MOVE,   0.15, Combat.TempMoveInProc,      5000.0, 7000.0, 9000.0, 0.35,1],
            [Combat.MOVE,   0.05, Combat.UsePotion,           3000.0, 7000.0, 9000.0, 1.00],
]
