import Bladex
import ObjStore
import Actions
import Reference
import Ontake
import CharStats



Reference.DefaultObjectData["FoodBag1"]=[Reference.OBJ_ITEM]
Reference.DefaultSelectionData["FoodBag1"]=(7.0,4000.0, "Food Bag")


Reference.DefaultObjectData["BagPie1"]=  [Reference.OBJ_STANDARD]
Reference.DefaultObjectData["BagDonut1"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["BagPizza1"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["roasted_chicken"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["pie"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["Garlic"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["Bananas_Regime"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["Fish01_Dm"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["Ham_dry"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["hanged_fishes"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["leek"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["mushroom_dm"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["red_apple"]=[Reference.OBJ_STANDARD]
Reference.DefaultObjectData["ribs"]=[Reference.OBJ_STANDARD]


Reference.DefaultSelectionData["BagPie1"]=(7.0,4000.0, "MeatPie")
Reference.DefaultSelectionData["BagDonut1"]=(7.0,4000.0, "Donut")
Reference.DefaultSelectionData["BagPizza1"]=(7.0,4000.0, "Pizza Slice")
Reference.DefaultSelectionData["roasted_chicken"]=(7.0,4000.0, "Roasted Chicken")
Reference.DefaultSelectionData["pie"]=(7.0,4000.0, "Pie")
Reference.DefaultSelectionData["Bananas_Regime"]=(7.0,4000.0, "Bananas")
Reference.DefaultSelectionData["Fish01_Dm"]=(7.0,4000.0, "Fish")
Reference.DefaultSelectionData["Ham_dry"]=(7.0,4000.0, "Ham")
Reference.DefaultSelectionData["hanged_fishes"]=(7.0,4000.0, "Fishes")
Reference.DefaultSelectionData["leek"]=(7.0,4000.0, "Leek")
Reference.DefaultSelectionData["mushroom_dm"]=(7.0,4000.0, "Mushroom")
Reference.DefaultSelectionData["red_apple"]=(7.0,4000.0, "Tomato")
Reference.DefaultSelectionData["ribs"]=(7.0,4000.0, "Ribs")
Reference.DefaultSelectionData["Garlic"]=(7.0,4000.0, "Garlic")


eatsnd = Bladex.CreateSound('..\\..\\Sounds\\bugbite-bone2.wav', 'EatSnd')
eatsnd.Volume=1
eatsnd.MinDistance=10000
eatsnd.MaxDistance=20000



FoodHealth={"BagPie1"        	: (20,0),
            "BagDonut1"    	: (10,1),
            "BagPizza1"    	: (15,0),
            "roasted_chicken"  	: (25,0),
            "pie"  	        : (15,0),
            "Bananas_Regime"  	: (15,0),
            "Fish01_Dm"  	: (5,0),
            "Ham_dry"    	: (30,0),
            "hanged_fishes"  	: (20,0),
            "leek"       	: (5,1),
            "mushroom_dm"  	: (20,1),
            "red_apple"  	: (10,1),
            "ribs"  	        : (50,0),
            "Garlic"  	        : (5,1),
           }



def HaveIGotABag():
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()
	for id in range(inv.nObjects):
	  	for ob in Actions.GetListOfObjectsAt(inv,id):
	    		ent = Bladex.GetEntity(ob)
	      		if ent.Kind=="FoodBag1":	
				return ob
	return None




def CheckBag():
	char=Bladex.GetEntity("Player1")
	char.AnmEndedFunc=CheckFoodAfterPickup


def CheckFoodAfterPickup(entity):
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()
	robj=Bladex.GetEntity(char.InvRight)
	robj.Mass=1.75
	if not robj:
		return
	if FoodHealth.has_key(robj.Kind):
		inc=FoodHealth[robj.Kind][0]
		ven=FoodHealth[robj.Kind][1]
	else:
		inc=5
		ven=0
	bagname=HaveIGotABag()
	if bagname == None:
		
		print "I have no bag"
		# shall I eat it or drop it?
		if (char.Life+inc)>CharStats.GetCharMaxLife(char.Kind,char.Level):
			robj.ExcludeHitFor(char)
			inv.LinkRightHand("None")		
			inv.RemoveObject(robj.Name)
			impulse = char.Rel2AbsVector(-1000.0 * robj.Mass, -1000.0 * robj.Mass, 0.0)	
			robj.Impulse(impulse[0],impulse[1],impulse[2])	
			Actions.ReportMsg("I am not Hungry and I have no Food Bag")
			print "My bag is full and I have full life. Dropping food......"
		else:
			char.LaunchAnimation("eat00")
			char.AddAnmEventFunc("drinkingEvent",EatFoodWithoutBag)
			Actions.ReportMsg("I have no Food Bag but I am Hungry")
			print "My bag is full but I am hungry. Eating food......"
	else:
		print "I have a bag"
		# OK got a bag, is it full?
		mybag=Bladex.GetEntity(bagname)
		if len(mybag.Data.Contents)>= mybag.Data.MaxContents:
			Actions.ReportMsg("My Food Bag is Full")
			print "Bag Full"
			# drop or eat?
			# Bag full - check life - Life full and bag full - drop
			# Bag Full - check life - Life not full = eat
			if (char.Life+inc)>CharStats.GetCharMaxLife(char.Kind,char.Level):
				#drop it
				Actions.ReportMsg("I Can Carry No More Food and I am Not Hungry")
				char.LaunchAnimation("drp_r")
				Actions.RemoveFromInventory (char, robj,"DropRightEvent")
			else:
				#eat it
				char.LaunchAnimation("eat00")
				char.AddAnmEventFunc("drinkingEvent",EatFoodWithoutBag)
				Actions.ReportMsg("I Can Carry No More Food but I am Hungry")
		else:
			print "I have room in my bag"
			# stash food
			char.AddAnmEventFunc("ChangeREvent",StashFood)
			
			
			char.LaunchAnmType("Dwf_bag")
			
			#else:
			#	char.LaunchAnmType("Kgt_bag")
			#char.LaunchAnmType("bag")
			
			

			
		
		
def EatFoodWithoutBag(Eater,Event):
	char=Bladex.GetEntity(Eater)
	char.DelAnmEventFunc(Event)
	inv = char.GetInventory()
	robj=Bladex.GetEntity(char.InvRight)
	if not robj:
		return
	inv.LinkRightHand("None")
	inv.RemoveObject(robj.Name)		
	Actions.TakeStraightRecover(Eater)
	if FoodHealth.has_key(robj.Kind):
		inc=FoodHealth[robj.Kind][0]
		ven=FoodHealth[robj.Kind][1]
	else:
		inc=5
		ven=0
	char.Life=char.Life+inc
	if char.Data.Poisoned and ven==1:
		char.Data.UnVenom()
	eatsnd.Play(char.Position[0],char.Position[1],char.Position[2],0)
	print "yum yummy yum"

			
			
			
			
def StashFood(EntityName,Event):
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()
	char.DelAnmEventFunc(Event)
	robj=Bladex.GetEntity(char.InvRight)
	# won't get to here if no bag.....so func should never return None
	mybag=Bladex.GetEntity(HaveIGotABag())
	mybag.Data.AddFood(robj.Name)
	inv.LinkRightHand("None")
	robj.RemoveFromWorld()	
	Ontake.DelOnTakeEvent(robj.Name)





	


class FoodBag:
	def __init__ (self, me):
		me.UseFunc= self.UseStart
		self.UsedBy= "Player1"
		self.Contents=[]
		self.Agenum=0
		self.Using=0
		self.MaxContents=30
		self.FoodValue=0
		self.CurePoison=0
		self.FoodUsed=""
		self.ObjId=ObjStore.GetNewId() 
		ObjStore.ObjectsStore[self.ObjId]=self





	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,self.ObjId, 
			  self.UsedBy,
			  self.Contents,
			  self.Agenum,
			  self.Using,
			  self.MaxContents,
			  self.FoodValue,
		          self.CurePoison,
		          self.FoodUsed
		          )
				
				
	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.UsedBy=parm[2]
			self.Contents=parm[3]
			self.Agenum=parm[4]
			self.Using=parm[5]
			self.MaxContents=parm[6]
			self.FoodValue=parm[7]
			self.CurePoison=parm[8]
			self.FoodUsed=parm[9]
		else:
			self.UsedBy= "Player1"
			self.Contents=[]
			self.Agenum=0
			self.Using=0
			self.MaxContents=30
			self.FoodValue=0
			self.CurePoison=0
			self.FoodUsed=""
			self.ObjId=ObjStore.GetNewId() 
			ObjStore.ObjectsStore[self.ObjId]=self
		
		
		
	def AddFood(self,FoodName):
		self.Contents.append(FoodName)
		print FoodName+": Added to bag"
		print self.Contents
		
		
		
		
	def UseStart (self, ObjectName, use_from):
		if self.Using:
			return
		if use_from==Actions.USE_FROM_INV:
			self.Using=1
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,self.UseEnd,(ObjectName, use_from,))
			object= Bladex.GetEntity(ObjectName)
			if object: 
				object.UseFunc= 0
			
			if len(self.Contents)==0:
				Actions.ReportMsg("My Food Bag Is Empty")
				
			else:
				#Actions.ReportMsg("I have Food In My Bag")
				user=Bladex.GetEntity(self.UsedBy)
				# Get stuff out and eat it........
				# Iam I hungry...
				if user.Life==CharStats.GetCharMaxLife(user.Kind,user.Level):
					Actions.ReportMsg("I Am Not Hungry")
				else:
					if user.InCombat:
						Actions.ReportMsg("I Can Not Eat While I Am Fighting")
					else:
						if user.InvRight:
							Actions.FreeBothHands(user.Name)
							user.AnmEndedFunc=self.GetFoodFromBag
							return
							
						user.AddAnmEventFunc("ChangeREvent",self.PickFood)
						user.LaunchAnmType("bag")
						user.AnmEndedFunc=self.EatFood
						
			
	
	
	def GetFoodFromBag(self,entity):
		user=Bladex.GetEntity(self.UsedBy)
		user.AddAnmEventFunc("ChangeREvent",self.PickFood)
		user.LaunchAnmType("bag")
		user.AnmEndedFunc=self.EatFood
				
				
	def PickFood(self,UserName,Event):
		user=Bladex.GetEntity(self.UsedBy)
		user.DelAnmEventFunc(Event)
		inv=user.GetInventory()
		food=Bladex.GetEntity(self.Contents[0])
		self.Contents.remove(food.Name)
		
		if food:
			self.FoodUsed=food.Name
			if FoodHealth.has_key(food.Kind):
				self.FoodValue=FoodHealth[food.Kind][0]
				self.CuresPoison=FoodHealth[food.Kind][1]
			else:
				self.FoodValue=5
				self.CuresPoison=0
			food.PutToWorld()
			inv.LinkRightHand(food.Name)
			
			
		
	def EatFood(self,UserName):
		user=Bladex.GetEntity(self.UsedBy)
		food=Bladex.GetEntity(self.FoodUsed)
		if food:
			user.AddAnmEventFunc("drinkingEvent",self.FoodEaten)
			user.LaunchAnmType("eat00")
			
		
	
		
		
		
	def FoodEaten(self, Eater,Event):
		user=Bladex.GetEntity(self.UsedBy)
		user.DelAnmEventFunc(Event)
		inv = user.GetInventory()
		inv.LinkRightHand("")
		inv.RemoveObject(self.FoodUsed)		
		Actions.TakeStraightRecover(Eater)
		if (user.Life + self.FoodValue)>= CharStats.GetCharMaxLife(user.Kind,user.Level):
			user.Life=CharStats.GetCharMaxLife(user.Kind,user.Level)
			user.ResetWounds()
		else:
			user.Life=user.Life+self.FoodValue
		if user.Data.Poisoned and self.CuresPoison:
			user.Data.UnVenom()
		eatsnd.Play(user.Position[0],user.Position[1],user.Position[2],0)
		print "yum yum"


	def UseEnd (self,ObjectName, UserName):
		object= Bladex.GetEntity(ObjectName)
		if object: 
			object.UseFunc=self.UseStart
			self.Using=0
			
		
		
		
		
		
			
			
def PlaceFoodBag(name,pos,ori):
	bag=Bladex.CreateEntity(name,"FoodBag1",pos[0],pos[1],pos[2])
	bag.Orientation=ori[0],ori[1],ori[2],ori[3]
	bag.Static = 0
	bag.Data = FoodBag(bag)
	
	
	
def PlaceCollectableFood(name,pos,ori,KIND="Queso",scale=1.0):
	fd=Bladex.CreateEntity(name,KIND,pos[0],pos[1],pos[2])
	fd.Orientation=ori[0],ori[1],ori[2],ori[3]
	fd.Scale=scale
	fd.Static = 0
	Ontake.AddOnTakeEvent(name,CheckBag)