import Bladex
import math
import Reference
import AuxTran
import BCopy
import B3DLib
import GameStateAux
import AllyCombat
import Ally_Def
import Sparks
import Actions
import Basic_Funcs
import CharStats
import netgame
import AllyNPCTypes
import AniSoundAribeth



TRUE = 1==1
FALSE = not TRUE

PI = math.pi
TWOPI = PI*2


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	   #Two handed sword
W_FLAG_AXE=2	#Two handed axw
W_FLAG_SP=3		#Two handed spear


CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0


def InitNewTrails():
	trail=Bladex.GetTrailType("EstelaPurpura1")
	trail.Time2Live=0.6
	trail.Color=40,0,40
	trail.Transparency=0.5
	trail.ShrinkFactor=1.0
	trail=Bladex.GetTrailType("EstelaVerde1")
	trail.Time2Live=0.6
	trail.Color=0,40,0
	trail.Transparency=0.5
	trail.ShrinkFactor=1.0
	
InitNewTrails()



KatanaWepHit=[5, 9, 16, 28, 40, 50, 70, 90, 120, 145, 175, 210, 250, 300, 380, 440, 530, 600, 670, 750]
WepHit=[3, 7, 12, 25, 35, 45, 65, 85, 110, 125, 150, 180, 210, 240, 290, 350, 400, 480, 540, 700]
WepDef=[0, -3, -5, -10, -15, -20, -25, -30, -35, -40, -45, -50, -55, -60, -65, -70, -75, -80, -85,-90]


def SetWeaponsDamage(entity):
	global KatanaWepHit
	global WepHit
	global WepDef
	per=Bladex.GetEntity(entity)
	rwp=Bladex.GetEntity(per.InvRight)
	lvl=per.Level
	inv=per.GetInventory()
	if rwp:
		if rwp.Kind=="ProRHWep2":				
			if lvl>19:
				WEPOW=WepHit[19]
				WEPDEF=WepDef[19]
			else:
				WEPOW=WepHit[lvl]
				WEPDEF=WepDef[lvl]
			Reference.EntitiesObjectData[rwp.Name]=[Reference.OBJ_WEAPON, WEPOW, WEPDEF, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
		if rwp.Kind=="ProKatana1":
			if lvl>19:
				WEPOW=KatanaWepHit[19]
				WEPDEF=WepDef[19]
			else:
				WEPOW=KatanaWepHit[lvl]
				WEPDEF=WepDef[lvl]
			Reference.EntitiesObjectData[rwp.Name]=[Reference.OBJ_WEAPON, WEPOW, WEPDEF, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,16000,0,Reference.GolpeArmaEscudoMetal]]
		
	



def AmIArmed(entity):
	per=Bladex.GetEntity(entity)
	wp=Bladex.GetEntity(per.InvRight)
	if wp:
		return TRUE
	return FALSE


def UpdatePJWeaponDamage():
	char=Bladex.GetEntity("Player1")
	char.Data.SetWeaponsDamage()
	
	
def UpdateNPCWeaponDamage(entity):
	dor=Bladex.GetEntity(entity)
	dor.Data.SetWeaponsDamage()
	
	
def CallHelp(EntityName):	
	print"I am calling for help"
	char=Bladex.GetEntity("Player1")
	char.Data.CallHelp("Player1")
	

def CheckIfAlly (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:				
		try:
	           enemyName=me.Data.EnemyName
	           return FALSE                  # returns TRUE for enemies of Player
	        except AttributeError:  
	 	   return TRUE
	
stime3=-2

def IntermediateSelect(EntityName):
	MySelectEnemy()


def MySelectEnemy():
	global stime3
	time=Bladex.GetTime()
	if(time-stime3>0.1):
		import Select
		pj=Bladex.GetEntity("Player1")
		if pj.InvRight=="" and pj.InvRightBack<>"" and Reference.GiveObjectFlag(pj.InvRightBack)<>Reference.OBJ_QUIVER:
			if pj.AnmEndedFunc==IntermediateSelect:
				pj.AnmEndedFunc= None
			Actions.StdToggleWeapons("Player1")
			
			pj.AnmEndedFunc=IntermediateSelect
			return
		if(pj.Data.enemy_locked):
			Select.SelectNextEnemy(pj)#####
		else:
			Select.GetVisibleEnemies(pj)
			if(pj.Data.selected_enemy):
				pj.Data.enemy_locked=1
		stime3=time
		if pj.Data.selected_enemy:
			ene=Bladex.GetEntity(pj.Data.selected_enemy[0])
			if ene and ene.Person:
				if not CheckIfAlly(ene.Name):
					print "This guy is an ally"
					return
				pj.SetActiveEnemy(ene)
				
				
def AmIRelaxing(entity):
	per=Bladex.GetEntity(entity)
	if per.AnimName[:3] == "rlx" or per.AnimName[:3] == "Rlx":
		return 1
	return 0
	
	
new_combo_sound = Bladex.CreateSound('..\\..\\Sounds\\sesgado-lava.wav', 'NewComboSound')
new_combo_sound.Volume=1.0
new_combo_sound.MinDistance=5000
new_combo_sound.MaxDistance=20000	

##########################################################################################################################################################




class AllyAribeth (AllyNPCTypes.AllyChar):

	def __init__(self, me):
		AllyNPCTypes.AllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
	
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		AniSoundAribeth.AsignarSonidosAribeth(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWars/NUFiles/NUAribethStuff/AribethIcon.bmp","AribethIcon")
		Reference.EnemiesScorerData[self.Name]=("AribethIcon","Ari")	
		
		
		
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCAlly_state=AllyNPCTypes.AllyChar.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			return NPCAlly_state
		NPCAlly_state[1]["AllyAribeth"]=()
		return NPCAlly_state
	
	
	def __setstate__(self,parm):
		AllyNPCTypes.AllyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["AllyAribeth"]
			
	
	
	
	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			rwp=me.InvRight
			if rwp:
				print EntityName+"_Holding_"+rwp
				
				inv= me.GetInventory()
				if inv.HoldingShield: 
					me.BlockingPropensity = 1.0
					me.RangeDefenceCapable = TRUE
					print"I have a shield"
				else: 
					me.BlockingPropensity = 0.0
					me.RangeDefenceCapable = FALSE
					
				flag=Reference.GiveWeaponFlag(rwp)
				if flag==Reference.W_FLAG_1H:
					me.AttackList = BCopy.deepcopy(AllyAribeth1HAttackData)
					
				if flag==Reference.W_FLAG_2W:
					me.AttackList = BCopy.deepcopy(AllyAribeth2HAttackData)
					if me.Level>1:
						me.AttackList.append ([AllyCombat.ATTACK, 0.15,("GM23_2H",),500.0, 1000.0, 2800.0, 0.35],)   #death dealer
					if me.Level>3:
						me.AttackList.append ([AllyCombat.ATTACK, 0.12,("GM1_2H","GM9_2H",),500.0, 1000.0, 2800.0, 0.35],)    #sky smash
					if me.Level>4:
						me.AttackList.append ([AllyCombat.ATTACK, 0.05,("GI_2H","GM12_2H",),500.0, 1000.0, 2800.0, 0.35],) 
					if me.Level>5:	
						me.AttackList.append ([AllyCombat.ATTACK, 0.05,("G3_2H","GM41_2H",),500.0, 1000.0, 2800.0, 0.35],) 
					if me.Level>7:	
						me.AttackList.append ([AllyCombat.ATTACK, 0.05,("G2_2H","GM29_2H",),500.0, 1000.0, 2800.0, 0.35],) 
					
					
			
				if flag==Reference.W_FLAG_SP:
					me.AttackList = BCopy.deepcopy(AllyAribeth2HAttackData)
					
			else:
				me.AttackList = BCopy.deepcopy(AllyAribethUnarmedAttackData)
				
			
			
		
	def WakeMeUp(self,EntityName):
		Reference.debugprint(EntityName+": I am waking up")
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE	
			print EntityName+" I am waking up"
				
				
	def PutMeToSleep(self,EntityName):
		Reference.debugprint(EntityName+": I am going to sleep")
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE
			
	
			
AllyAribeth1HAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.015, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.30,("GM1_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.20,("GM2_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM3_1H",),500.0, 1800.0, 2500.0, 0.35],             # left
	    [AllyCombat.ATTACK, 0.20,("GM4_1H",),500.0, 1800.0, 2500.0, 0.35],             # right
	    [AllyCombat.ATTACK, 0.05,("GI_1H",), 500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM23_1H",),500.0, 1200.0, 2200.0, 0.35],           # north cross
	    [AllyCombat.ATTACK, 0.15,("GM38_1H",),500.0, 1200.0, 2200.0, 0.35],           # gladius
					
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		


AllyAribeth2HAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.015, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	    [AllyCombat.ATTACK, 0.15,("GI_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM4_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM2_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.10,("GM3_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.15,("GM1_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.12,("GM2_2H","GM10_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [AllyCombat.ATTACK, 0.05,("GM3_2H","GM8_2H",),500.0, 1000.0, 2800.0, 0.35],   
	    [AllyCombat.ATTACK, 0.12,("GM4_2H","GM11_2H",),500.0, 1000.0, 2800.0, 0.35], 
					
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		



AllyAribethSPAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.015, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	    [AllyCombat.ATTACK, 0.8, ("GM15_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM10_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.05, ("GI_SP",) ,1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GMI_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM8_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM6_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM3_SP",),1200.0, 1800.0, 2500.0, 0.35], 
					
					
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		


AllyAribethUnarmedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.015, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
	    [AllyCombat.ATTACK, 0.8, ("GM21_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM22_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM23_NO",),500.0, 1000.0, 1500.0, 0.35],
					
					
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		