import Bladex
import Reference
import BCopy
import AuxFuncs


class GoblinCatapult:
	def __init__(self, me):
		if not me.Actor:
			me.Weapon=1
		self.Name= me.Name
		String1= self.CreateAndAttachString (self.Name+"StringTop", me.GraspPos("Top"))
		self.String1Name= String1.Name
				
		String2= self.CreateAndAttachString (self.Name+"StringBottom", me.GraspPos("Bottom"))
		self.String2Name= String2.Name
		
		self.UnGraspString()

	def CreateAndAttachString (self, StringName, Position):
		bow= Bladex.GetEntity (self.Name)
		String= Bladex.CreateEntity (StringName, "Entity ElectricBolt",Position[0],Position[1],Position[2])
		bow.Link (String)
		String.Position= Position
		String.OuterGlowColor= (0,0,0)
		String.InnerGlowColor= (0,0,0)
		String.CoreGlowColor= (10,10,10)
		String.Damage= 0
		String.MaxAmplitude= 2
		String.FixedTarget= 0
		String.SimpleSections= 1
		return String


	def GraspString (self):
		bow= Bladex.GetEntity (self.Name)
		holder_name= bow.Parent
		if holder_name:
			holder= Bladex.GetEntity (holder_name)
			arrow= Bladex.GetEntity(holder.InvRight)
			if arrow and arrow.Arrow:
				tx,ty,tz= holder.GraspPos("R_Hand")
				
				String1= Bladex.GetEntity(self.String1Name)
				String1.ETarget= arrow.Name
				String1.Target= tx,ty,tz
				String1.Active= 1
				
				String2= Bladex.GetEntity(self.String2Name)
				String2.ETarget= arrow.Name
				String2.Target= tx,ty,tz
				String2.Active= 1


	def UnGraspString (self):
		bow= Bladex.GetEntity (self.Name)
		String1= Bladex.GetEntity (self.String1Name)
		String1.ETarget= ""
		x,y,z= bow.GraspPos ("Bottom")
		String1.Target= x,y,z
		String1.Active= 1
		String2= Bladex.GetEntity (self.String2Name)
		String2.ETarget= ""
		String2.Active= 0
		holder_name= bow.Parent
		if holder_name:
			holder= Bladex.GetEntity (holder_name)
			holder.Data.CreateAndFireRock(self.Name)







class GoblinQuiver:
	def __init__ (self, me):
		me.Static=0
		
		me.Alpha=0.0
		me.CastShadows=0

		object_data = None
		if Reference.EntitiesObjectData.has_key(me.Name):
			object_data = Reference.EntitiesObjectData[me.Name]
		elif Reference.DefaultObjectData.has_key(me.Kind):
			object_data = Reference.DefaultObjectData[me.Kind]
			
		self.MaxArrows= 12
		self.ArrowType="FlechaGoblin"

		self.ArrowsLeft= self.MaxArrows
		self.ArrowsFriendlyName= self.ArrowType

		self.Name= me.Name
		
		self.BaseKind= me.Kind
		
		self.ArrowsUsed= 0
		self.ArrowCache=[]
		for i in range (self.MaxArrows):
			self.ArrowCache.append (self.Name+"_Stone_"+`i`)
			

	def GetFirstArrow (self, allow_parented=0, allow_flying=0):
		for arrow_name in self.ArrowCache:
			arrow= Bladex.GetEntity (arrow_name)
			if not arrow:
				arrow= Bladex.CreateEntity(arrow_name,self.ArrowType,0,0,0,"Arrow")
			if arrow.Parent:
				parent= Bladex.GetEntity(arrow.Parent)
				parent.Data.CurrentArrow=arrow.Name
				print "Current Goblin Arrow set: ",arrow.Name
			flying= arrow.Velocity!=(0.0, 0.0, 0.0)
			if (allow_parented or not arrow.Parent) and (allow_flying or not flying):
				if arrow.Parent:
					parent= Bladex.GetEntity(arrow.Parent)
					
					if parent: 
						
						parent.Unlink(arrow)
						
				arrow.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				arrow.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				if flying:
					arrow.Stop()
				arrow.Position=0,0,0
				self.ArrowCache.remove(arrow_name)
				self.ArrowCache.append(arrow_name)
				return arrow
		if not allow_parented:
			return self.GetFirstArrow(1)
		else:
			# Returning flying arrows has some strange visual side effects
			return self.GetFirstArrow(1, 1)
	
	
	# 9, 16, 25, 36, 49, 64, 81,100,121,144,169,196,225,256,289,324,361,400,441,484
	
	def GiveArrow (self, owner_name=""):
		if self.ArrowsLeft > 0:
			arrow= self.GetFirstArrow()
			# debug
			if arrow.Parent:
				print "GiveArrow giving arrow with parent"
			
			if not owner_name:
				me= Bladex.GetEntity(self.Name)
				owner_name= me.Parent
			if owner_name:
				owner=Bladex.GetEntity(owner_name)
				if owner and owner.Person: 
					lvl=owner.Level+3 
					if lvl<18:
						lvlfactor=lvl*lvl
					else:
						lvlfactor=550
					racemultiplier=1 # other races of goblin can be stronger
					dam=lvlfactor*racemultiplier
					firedam=lvlfactor  
					
					
					if not Reference.EntitiesObjectData.has_key(arrow.Name):
						Reference.EntitiesObjectData[arrow.Name]= BCopy.deepcopy(Reference.DefaultObjectData[arrow.Kind])
						Reference.EntitiesObjectData[arrow.Name][1]= dam
						#if arrow.Kind=="FlechaEnvenenada":
						#	Reference.EntitiesObjectData[arrow.Name].append(['Venom', +lvl])
						#if arrow.Kind=="FlechaFuego":
						#	Reference.EntitiesObjectData[arrow.Name].append(['Fire', +firedam])
					print"Goblin Stone damge set at"
					print dam
					if owner.Name=="Player1":
						self.SetNumberOfArrows (self.ArrowsLeft-1)
			else:
				print "Arrow given from quiver with no parent"
			self.ArrowsUsed= self.ArrowsUsed+1
			arrow.CastShadows= 1
			arrow.Alpha=0.0
			
			return arrow
	
	
	
	
	def ReceiveArrow (self, entity, owner_name=""):
		if entity and entity.Arrow and entity.Kind==self.ArrowType:
			if not owner_name:
				me= Bladex.GetEntity(self.Name)	
				owner_name= me.Parent
			if owner_name:
				owner=Bladex.GetEntity(owner_name)
				if owner and owner.Person and owner.Data:
					if Reference.EntitiesObjectData.has_key(entity):
						del Reference.EntitiesObjectData[entity]
					if owner.Name=="Player1":
						if self.ArrowsLeft < self.MaxArrows:
							self.SetNumberOfArrows (self.ArrowsLeft+1,owner_name)
						else:
							return 0
			else:
				print "Arrow received to quiver with no parent"
			entity.SubscribeToList("Pin")
			return 1
		return 0




	def ReceiveArrows (self, num_arrows, owner_name=""):
		if not owner_name:
			me= Bladex.GetEntity(self.Name)
			owner_name= me.Parent
		if owner_name:
			owner=Bladex.GetEntity(owner_name)
			if owner and owner.Person and owner.Data:
				if owner.Name=="Player1":
					self.SetNumberOfArrows (min (self.ArrowsLeft+num_arrows, self.MaxArrows),owner_name)
		
	
	def NumberOfArrows (self):
		return self.ArrowsLeft
	

	def SetNumberOfArrows(self, num, owner_name=""):
		self.ArrowsLeft=num
		






	
	

