import Bladex
import Enm_Def
import ObjStore
import GameStateAux
import BCopy
import AuxFuncs
import Combat
import Reference
import ItemTypes
import InitDataField
import B3DLib
import Actions
import Basic_Funcs
import CharStats
import Damage
import Actions
import math
import whrandom

import AniSoundHorror



TRUE = 1==1
FALSE = not TRUE



CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear

ROUTE_WATCH=0  #Watch mode
ROUTE_BAY=1    #Performing a bay route
ROUTE_CHASE=2  #Chase a character
ROUTE_SINGLE=3 #Following a single route (going to just a point)
ROUTE_BOWING=4 #Bowing (OR trying to bow) an enemy





def CheckIfEnemy (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:		
		try:
	           	enemyName=me.Data.EnemyName
	           	return TRUE                       
	        except AttributeError:  
	 	   	return FALSE   

	 	   
def IsHoldingBow(EntityName):
	me=Bladex.GetEntity(EntityName)
	ObjectName=me.InvLeft
	object_flag=Reference.GiveObjectFlag(ObjectName)
	if object_flag==Reference.OBJ_BOW:
		return TRUE
	return FALSE
		

# Poison breath

Bladex.AddParticleGType("Halitosis","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,128)

for i in range(128):
	if i>64:
		traux=0.0
	else:
		traux=(64.0-i)/64.0
	aux=(128.0-i)/128.0
	r=110
	g=145
	b=90
	a=150.0*(1.0-traux)**0.5
	size=10.0+aux*1200.0
	Bladex.SetParticleGVal("Halitosis",i,r,g,b,a,size)
	
###########################################################################################################################################################
#### Base Enemy Class


class EnemyCharHorror (Enm_Def.NPCPerson):

	clawname=""
	DeathFunc=None
	DeathArgs=()
	AGE_Number=0

	NameOfEnemy=None
	
	def __init__(self, me):
		Enm_Def.NPCPerson.__init__(self, me)
		
		self.clawname=""
		self.DeathFunc=None
		self.DeathArgs=()
		self.AGE_Number=0
		
		self.dissapsound1=Bladex.CreateSound("..\\..\\Sounds\\rugido-wyverna.wav", "DissappearSound1")
		self.dissapsound1.Volume=1.0
		self.dissapsound1.Pitch=1.6
		self.dissapsound1.MinDistance=10000
		self.dissapsound1.MaxDistance=20000
		
		self.dissapsound2=Bladex.CreateSound("..\\..\\Sounds\\fireball-swing.wav", "DissappearSound2")
		self.dissapsound2.Volume=1.0
		self.dissapsound2.MinDistance=10000
		self.dissapsound2.MaxDistance=20000
		
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		me.ImDeadFunc=self.NUImDeadFunc
		
		self.GrowClaw()
		
		
	def StdEnemyDead(self,EntityName):
		Enm_Def.NPCPerson.StdEnemyDead(self,EntityName)
		Reference.debugprint(EntityName+": My enemy is really dead.He he ! - py")
		if not self.MyGetEnemyName():
			self.LookForAnotherOpponent(EntityName)
		
	
	
	def StdStartChase(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		enemy=Bladex.GetEntity(me.GetEnemyName())
		me.AnmEndedFunc=self.StdAnmEnded
		if enemy.InsideActionArea(me.ActionAreaMax) or (self.IsArcher() and me.InsideActionArea(me.ActionAreaMax)):
			if not IsHoldingBow(enemy.Name):
				self.StdStartChase2 (EntityName)
				if self.NameOfEnemy:
					print EntityName+" I am chasing "+self.NameOfEnemy
		else:
			# The following is to turn to face the enemy when we are already at an illegal border
			self.StdSeeEnemyUnreachable (EntityName)	
		
		

	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
		Reference.debugprint(EntityName + ": Enemy Unreachable")
		if Bladex.GetTime()-self.LastThrownHurtTime<Enm_Def.THROWNHURTTIME_GAP:
			return
		if me.InsideActionArea(me.ActionAreaMin) and (check1aaTo2aa and not me.Will1aaTo2aa):

			if me.Data.goto_limit2aa:
				back_area_min=me.ActionAreaMin
				back_area_max=me.ActionAreaMax
				me.ActionAreaMin=0
				me.ActionAreaMax=0
				enemy=Bladex.GetEntity(me.GetEnemyName())
				if enemy and IsHoldingBow(enemy.Name):
					print EntityName+" I am chasing an archer!!"
					return
				des_pos=enemy.Position
				me.GoToJogging=1
				if me.GoTo(des_pos[0],des_pos[1],des_pos[2]):
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
				else: 
					Reference.debugprint(EntityName + ": GoTo enemy_pos not working, with action area 0!")
					me.ActionAreaMin=back_area_min
					me.ActionAreaMax=back_area_max
			return
		elif me.InsideActionArea(me.ActionAreaMin):
			if me.GetActionMode() != ROUTE_WATCH:
				self.LaunchMyWatch (EntityName)
			if not Actions.IsFacingEntity(EntityName, me.GetEnemyName()):
				Actions.TurnToFaceEntity(EntityName, me.GetEnemyName())
			else:
				curr_time=Bladex.GetTime()
				if curr_time-self.last_insulting_time_1AA>4:
					insult_prob=whrandom.uniform(0.0, 1.0)
					if insult_prob<0.8:
						Combat.Insult(EntityName)
					insult_var=whrandom.uniform(-2.0, 1.0)
					self.last_insulting_time_1AA=Bladex.GetTime()+insult_var
		else:
			back_area_min=me.ActionAreaMin
			back_area_max=me.ActionAreaMax
			me.ActionAreaMax= 0
			me.ActionAreaMin= 0
			
			init_pos=me.InitPos
			me.InvertedRoute=1 # Move backwards
			if me.GoTo(init_pos[0],init_pos[1],init_pos[2]):
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max
			else:
				Reference.debugprint(EntityName + ": GoTo init_pos not working, with action area 0!")
				me.ActionAreaMin=back_area_min
				me.ActionAreaMax=back_area_max

			
				
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.NameOfEnemy or Bladex.GetEntity(self.NameOfEnemy).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		char=Bladex.GetEntity("Player1")
                   		if me.CanISee(char):
	  				self.NameOfEnemy="Player1"
                   			enemy=Bladex.GetEntity(self.NameOfEnemy)
                			me.SetEnemy(enemy)
					return self.NameOfEnemy			
                   		else:
                   			return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.NameOfEnemy=enemyList[0]
		enemy=Bladex.GetEntity(self.NameOfEnemy)
                me.SetEnemy(enemy)
                
		return self.NameOfEnemy			
				
				
		
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Alpha<0.9:
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		if IsHoldingBow(entity.Name):
			return FALSE
		if  CheckIfEnemy(entity.Name): 
			return TRUE
		else:
			return FALSE
			

	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)
		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER


	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			Reference.debugprint (EntityName + ": I spy a GOOD guy")
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					Reference.debugprint (EntityName + ": Your Name is "+ene.Name+ " I will do you over")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Enm_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Enm_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==Enm_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							#print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()




					
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				#####################################################################
				# consider getting furious
				#chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				#if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
				#	self.GetFurious (EntityName)
				# consider attacking attacker back
				#damage_factor = DamagePoints / (me.Life+DamagePoints)
				#if damage_factor > me.Data.DamageFactorNone:
				#	# Only if I'm still alive... Death events handled apart
				####################################################################
				#Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
					
				if self.NameOfEnemy and self.NameOfEnemy != AttackerName:
					#Reference.debugprint(AttackerName+": Is NOT my current enemy")
					attacker = Bladex.GetEntity(AttackerName)
					##########################################
					if IsHoldingBow(AttackerName):
						print EntityName+" My Enemy is an Archer"
						return
					
					if attacker and (self.AttacksOwnKind or attacker.Kind != me.Kind):
						
						Reference.debugprint(EntityName+": I will respond")
						# Only attack NPCs if not already, otherwise we get multiple scheduled funcs
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							#Reference.debugprint("attacker.Data.NPC: "+ `attacker.Data.NPC`+ ", self.AttackingNPC: " + `self.AttackingNPC`)
								
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		
	
				
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if (not self.Asleep) and (not me.Blind):
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
				me.StopLooking()
				self.PutMeToSleep(EntityName)
				if not self.NameOfEnemy:
					self.LookForAnotherOpponent(EntityName)
				Reference.debugprint(EntityName+": I have got bored and dropped to sleep")
				
							
				
				
	def LookForAnotherOpponent(self,EntityName):
		Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		#self.LaunchMyWatch (EntityName)
		mep=me.Position
		enelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 30000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					enelist.append(en.Name)
		if len (enelist) == 0: 
                   	return 
                enelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(enelist[0])
                if nearest:
			me.GoToJogging=0
			me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
			me.RouteEndedFunc=self.LaunchMyWatch
			print EntityName+" I have found a new enemy and I am going to sort the bugger out "
					
                    				
		       			
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			me.Deaf=1
			self.Asleep = TRUE


	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			me.Deaf=0
			self.Asleep = FALSE
			
		
	def OnKilledEnemy(self,KilledEntityName):
		print "Demon Leveling up"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.LookForAnotherOpponent,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.7, 0.6, 0.7, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			DemonLevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, maxint, "Timer15", 15)
			if me.Life >0: 
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			self.UpgradeMyClaw()
			
				
			
	def UpgradeMyClaw(self):
		me = Bladex.GetEntity(self.Name)
		reallvl=me.Level+2
		clwdam=reallvl*reallvl
		vdam=reallvl*2
		fdam=clwdam*reallvl
		xdam=clwdam*2
		if self.clawname:
			Reference.EntitiesObjectData[self.clawname][1]=clwdam
				
		
	def GrowClaw(self):
		me = Bladex.GetEntity(self.Name)
		inv=me.GetInventory()
		dclaw=Bladex.CreateEntity(self.Name+"_Claw","ProWolfClaw",0,0,0, "Weapon")
		dclaw.Scale=2.5
		dclaw.Alpha=0.0
		dclaw.RasterMode="Read"
		dclaw.CastShadows=0
		inv.AddWeapon(dclaw.Name)
		inv.LinkRightHand(dclaw.Name)
		self.clawname=dclaw.Name
		Reference.EntitiesObjectData[self.clawname]=[Reference.OBJ_WEAPON, 1, 0, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
		self.UpgradeMyClaw()
		print "Demon claw attached"
			



	def MoveMeAway(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Position=0,30000,0


	def NUImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.UnlinkChildren()
		inv=me.GetInventory()
		wps=Bladex.CreateEntity(EntityName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
		wps.PersonName=EntityName
		wps.ParticleType="DeathCloud"
		wps.Time2Live=16
		wps.RandomVelocity=2.0
		wps.Velocity=0,0,0
		wps.NormalVelocity=2
		wps.YGravity=0
		wps.DeathTime=Bladex.GetTime()+5.50
		wps.PPS=1024
		me.Alpha=1.0
		me.RasterMode="Read"
		me.CastShadows=0
		AuxFuncs.FadeObject(me.Name, 1.00, 0.0, 3.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+5.1,self.MoveMeAway,(EntityName,))
		self.dissapsound1.Play(me.Position[0], me.Position[1], me.Position[2], 0)
		#self.dissapsound2.Play(me.Position[0], me.Position[1], me.Position[2], 0)
		if self.clawname:
			dclaw=Bladex.GetEntity(self.clawname)
			Actions.RemoveFromInventory(me, dclaw,"DropRightEvent")
			dclaw.Alpha=0.0
			dclaw.Position=0,50000,0
		if(self.DeathFunc):
			apply(self.DeathFunc,self.DeathArgs)
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.SetTmpAnmFlags(1,1,1,0,5,1)
		me.LaunchAnimation("Ldm_dth_disap")
		print"Demon disappeared"	
				
	
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["EnemyCharHorror"]=(self.NameOfEnemy,self.dissapsound1,
						self.dissapsound2,
						GameStateAux.SaveFunctionAux(self.DeathFunc),
						self.DeathArgs,
						self.clawname,
						self.AGE_Number)
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["EnemyCharHorror"]
			self.NameOfEnemy=parms[0]
			self.dissapsound1=parms[1]
			self.dissapsound2=parms[2]
			GameStateAux.LoadFunctionAux(parms[3],self,"DeathFunc")
			self.DeathArgs=parms[4]
			self.clawname=parms[5]
			self.AGE_Number=parms[6]
			
		self.dissapsound1=Bladex.CreateSound("..\\..\\Sounds\\rugido-wyverna.wav", "DissappearSound1")
		self.dissapsound1.Volume=1.0
		self.dissapsound1.Pitch=1.2
		self.dissapsound1.MinDistance=10000
		self.dissapsound1.MaxDistance=20000
		
		self.dissapsound2=Bladex.CreateSound("..\\..\\Sounds\\fireball-swing.wav", "DissappearSound2")
		self.dissapsound2.Volume=1.0
		self.dissapsound2.MinDistance=10000
		self.dissapsound2.MaxDistance=20000
		
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		me=Bladex.GetEntity(self.Name)
		me.ImDeadFunc=self.NUImDeadFunc



class Horror (EnemyCharHorror):

	def __init__(self, me):
			
		EnemyCharHorror.__init__(self, me)
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
			
		

		
	def ResetSounds(self, EntityName):
		AniSoundHorror.AsignarSonidosHorror(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NULesserDemonStuff/Horror_AIcon.bmp","Horror_AIcon")
		Reference.EnemiesScorerData[self.Name]=("Horror_AIcon","Hrr")
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(HorrorAttackData)
			me.BlockingPropensity= 0.4

		
		
		
	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=EnemyCharHorror.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["Horror"]=()
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyCharHorror.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Horror"]
		
		
		


HorrorAttackData =	[ 
           # inner zone blocks:
            
			         
           # attacks:
            [Combat.ATTACK, 0.20, ("G03",),            2085.0, 2500.0, 2829.0, 0.35],
            [Combat.ATTACK, 0.20, ("G06",),            3217.0, 3700.0, 3997.0, 0.35],
            [Combat.ATTACK, 0.90, ("G07",),            2400.0, 2500.0, 2600.0, 0.35],
            [Combat.ATTACK, 0.10, ("G22",),            3097.0, 3700.0, 3855.0, 0.35],
            [Combat.ATTACK, 0.10, ("G27",),            2274.0, 2600.0, 2700.0, 0.35],
            [Combat.ATTACK, 0.20, ("ZIG",),            5000.0, 9000.0,12000.0, 0.53],
            [Combat.ATTACK, 0.20, ("ZAG",),            5000.0, 9000.0,12000.0, 0.57],
]



class LesserDemon (EnemyCharHorror):

	def __init__(self, me):
			
		EnemyCharHorror.__init__(self, me)
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
			
		
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
	def ResetSounds(self, EntityName):
		AniSoundHorror.AsignarSonidosHorror(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NULesserDemonStuff/LesserDemon_AIcon.bmp","LesserDemon_AIcon")
		Reference.EnemiesScorerData[self.Name]=("LesserDemon_AIcon","Hrr")
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(LesserDemonAttackData)
			me.BlockingPropensity= 0.4
	



	

	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Horror_A":
					me=Bladex.GetEntity(self.Name)
					lvl=me.Level+1
					firepow=lvl*lvl
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +firepow]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						if victim.InCombat:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()





	def SpitFunc(self, fireball_name,end_time,period):		
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period))
				
	
	def StartSpit (self,EntityName,EventName):		
		me = Bladex.GetEntity(EntityName)
		if me.InCombat: 
			
			# Get an angle to the target
			if self.NameOfEnemy:
				target= Bladex.GetEntity(self.NameOfEnemy)
			else:
				return
				
			target_pos= target.Position
			x,y,z= me.GraspPos("Mouth")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			
			# fan out spit
			duration= 0.3
			self.AGE_Number=self.AGE_Number+1
			end_time=Bladex.GetTime()+duration
			period= duration/10.0
			fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
			fireball.ParticleType="Flame"
			fireball.Time2Live=20
			fireball.YGravity=-500.0
			fireball.Friction=0.12
			fireball.PPS=512
			fireball.DeathTime=end_time;
			F= 7000.0             # Vector magnitude
			vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
			fireball.Velocity=vx,vy,vz
			fireball.RandomVelocity=55.0
			node= me.GetNodeIndex("Head")
			me.LinkToNode(fireball,node)
			self.SpitFunc(fireball.Name, end_time, period)			
	
	
	
	
	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=EnemyCharHorror.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["LesserDemon"]=()
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyCharHorror.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["LesserDemon"]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		


LesserDemonAttackData =	[ 
           		         
           # attacks:
            [Combat.ATTACK, 0.40, ("SP1",),               0.0, 1500.0, 3000.0, 0.35],
            [Combat.ATTACK, 0.20, ("G03",),            1000.0, 1500.0, 2829.0, 0.35],
            [Combat.ATTACK, 0.20, ("G06",),            1000.0, 2200.0, 3997.0, 0.35],
            [Combat.ATTACK, 0.90, ("G07",),            1100.0, 2200.0, 2600.0, 0.35],
            [Combat.ATTACK, 0.10, ("G22",),            1100.0, 2200.0, 2855.0, 0.35],
            [Combat.ATTACK, 0.10, ("G27",),            2074.0, 2600.0, 2700.0, 0.35],
            [Combat.ATTACK, 0.20, ("ZIG",),            5000.0, 9000.0,12000.0, 0.53],
            [Combat.ATTACK, 0.20, ("ZAG",),            5000.0, 9000.0,12000.0, 0.57],
]




class Slaad (EnemyCharHorror):

	def __init__(self, me):
			
		EnemyCharHorror.__init__(self, me)
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
			
		
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		
		
	def ResetSounds(self, EntityName):
		AniSoundHorror.AsignarSonidosHorror(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NULesserDemonStuff/LesserDemon_BIcon.bmp","LesserDemon_BIcon")
		Reference.EnemiesScorerData[self.Name]=("LesserDemon_BIcon","Hrr")
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(SlaadAttackData)
			me.BlockingPropensity= 0.4
	





	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Horror_A":
					me=Bladex.GetEntity(self.Name)
					lvl=me.Level+1
					venompow=lvl*2
				
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +venompow]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Venom", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="Halitosis"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						if victim.InCombat:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()



	def SpitFunc(self, fireball_name,end_time,period):		
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period))
				
	
	def StartSpit (self,EntityName,EventName):		
		me = Bladex.GetEntity(EntityName)
		if me.InCombat: 
			
			# Get an angle to the target
			if self.NameOfEnemy:
				target= Bladex.GetEntity(self.NameOfEnemy)
			else:
				return
				
			target_pos= target.Position
			x,y,z= me.GraspPos("Mouth")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			
			# fan out spit
			duration= 0.3
			self.AGE_Number=self.AGE_Number+1
			end_time=Bladex.GetTime()+duration
			period= duration/10.0
			fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
			fireball.ParticleType="Halitosis"
			fireball.Time2Live=20
			fireball.YGravity=-500.0
			fireball.Friction=0.12
			fireball.PPS=512
			fireball.DeathTime=end_time;
			F= 7000.0             # Vector magnitude
			vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
			fireball.Velocity=vx,vy,vz
			fireball.RandomVelocity=55.0
			node= me.GetNodeIndex("Head")
			me.LinkToNode(fireball,node)
			self.SpitFunc(fireball.Name, end_time, period)			
	
	
		
		
	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=EnemyCharHorror.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["Slaad"]=()
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		EnemyCharHorror.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Slaad"]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		


SlaadAttackData =	[ 
           		         
           # attacks:
            [Combat.ATTACK, 0.40, ("SP1",),               0.0, 1500.0, 3000.0, 0.35],
            [Combat.ATTACK, 0.20, ("G03",),            1000.0, 1500.0, 2829.0, 0.35],
            [Combat.ATTACK, 0.20, ("G06",),            1000.0, 2200.0, 3997.0, 0.35],
            [Combat.ATTACK, 0.90, ("G07",),            1100.0, 2200.0, 2600.0, 0.35],
            [Combat.ATTACK, 0.10, ("G22",),            1100.0, 2200.0, 2855.0, 0.35],
            [Combat.ATTACK, 0.10, ("G27",),            2074.0, 2600.0, 2700.0, 0.35],
            [Combat.ATTACK, 0.20, ("ZIG",),            5000.0, 9000.0,12000.0, 0.53],
            [Combat.ATTACK, 0.20, ("ZAG",),            5000.0, 9000.0,12000.0, 0.57],
]


#########################################################################################################################################################
########## LevelUp FX


# LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)

def DemonLevelUpFX(EntityName,ColourGradation, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, LightIntensity, timer="Timer15", timespersec=15):

	# ColourGradation=0/1
	# AuraParams=(Size, Alpha, ColourIntensity, HideFrontFaces, HideBackFaces, AlphaMode)
	# AuraGradient=(Gap, r1, g1, b1, alpha1, StartingPoint, r2, g2, b2, alpha2, EndingPoint)
	# AuraVarArgs=(init_size, end_size, init_alpha, end_alpha, time)
	# PSParams=(LevelUpParticleData, ParticleType, ParticleLife, r, g, b, PPS, YGravity, Friction, RandomVelocity, NormalVelocity, FollowFactor, Time2Live, DeathTime)

	ent=Bladex.GetEntity(EntityName)
	if ColourGradation:
		maxlevel=CharStats.GetMaxLevel()
		frlevel=maxlevel/4.0
		fr1level=round(frlevel)
		fr2level=round(2.0*frlevel)
		fr3level=round(3.0*frlevel)
		clevel=ent.Level
		if clevel>fr3level:
			r=255
			g=255*(min(max(0, (maxlevel-clevel)/(maxlevel-fr3level)), 1)) # 255->0
			b=0
		elif clevel>fr2level:
			r=255*(min(max(0, (clevel-fr2level)/(fr3level-fr2level)), 1)) # 0->255
			g=255
			b=0
		elif clevel>fr1level:
			r=0
			g=255
			b=255*(min(max(0, (fr2level-clevel)/(fr2level-fr1level)), 1)) # 255->0
		else:
			r=0
			g=255*(min(max(0, (clevel/fr1level)), 1)) # 0->255
			b=255
		AuraGradient=(AuraGradient[0], r/255.0, g/255.0, b/255.0, AuraGradient[4], AuraGradient[5], r/255.0, g/255.0, b/255.0, AuraGradient[9], AuraGradient[10])
	
	
	AuraName=EntityName+"AuraLevelUp"
	a2, b2, c2, d2, e2, f2, g2, h2, i2, j2, k2=AuraName, AuraVar2Args[0], AuraVar2Args[1], AuraVar2Args[2], AuraVar2Args[3], AuraVar2Args[4], 1, "", (), timer, timespersec
	a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1=AuraName, AuraVar1Args[0], AuraVar1Args[1], AuraVar1Args[2], AuraVar1Args[3], AuraVar1Args[4], 0, AuxFuncs.FadeAndScaleAura, (a2, b2, c2, d2, e2, f2, g2, h2, i2, j2, k2), timer, timespersec
	alup=Bladex.CreateEntity(AuraName, "Entity Aura", 0, 0, 0)
	alup.SetAuraParams(AuraParams[0], AuraParams[1], AuraParams[2], AuraParams[3], AuraParams[4], AuraParams[5])
	alup.SetAuraGradient(AuraGradient[0], AuraGradient[1], AuraGradient[2], AuraGradient[3], AuraGradient[4], AuraGradient[5], AuraGradient[6], AuraGradient[7], AuraGradient[8], AuraGradient[9], AuraGradient[10])
	ent.Link(alup)
	alup.SetAuraActive(1)
	AuxFuncs.FadeAndScaleAura(a1, b1, c1, d1, e1, f1, g1, h1, i1, j1, k1)
	
	
	llup=Bladex.CreateEntity(EntityName+"LightLevelUp", "Entity Spot", 0, 0, 0)
	llup.Color=r, g, b
	llup.Intensity=0.0
	llup.Precission=0.01
	llup.CastShadows=0
	llup.Visible=0
	llup.Flick=0
	ent.Link(llup)
	AuxFuncs.SpotIntensityVariation(llup.Name, 0.0, LightIntensity, f1/1.6, 0, 0.0, 0.0, timer, timespersec)
	Bladex.AddScheduledFunc(Bladex.GetTime()+f1, AuxFuncs.SpotIntensityVariation, (llup.Name, LightIntensity, 0.0, f2/1.2, 1, 0.0, 0.0, timer, timespersec))
	
