import Bladex
import math

##########################
# Create New Biped Data  #
##########################


    ####################
    #                  #
    # Umberhulk        #
    #                  #
    ####################
    


    
    
import UmberhulkAnm_def
UmberhulkAnm_def.InitUmberhulk()    
 
 
umb=Bladex.GetCharType("Umberhulk","Umb")
umb.IntName="Umb" 

umb.TurnSpeed=4.5
umb.Jcost=2700
umb.MaxFall=4000
umb.DieFall=14000
umb.MaxStair=335
umb.Fov=math.pi
umb.MaxGrab=3500.0
umb.MedGrab=2500.0
umb.Min2Grab=1500.0

umb.MinTake=-500.0		# Min height above floor barbarian will take
umb.MaxTake1=250.0	# Max height above floor for Take1 Anim
umb.MaxTake2=550.0	# Max height above floor for Take2 Anim
umb.MaxTake3=1300.0	# Max height above floor for Take3 Anim
umb.MaxTake4=1900.0	# Max height above floor for Take4 Anim
umb.MaxTake5=3000.0	# Max height above floor for Take5 Anim
umb.Reach=2000.0	# Max distance from tkn centre to obj centre to take

umb.MovFrwdSpeedInStrafe=1000  #Forwards speed when in strafe(combat mode only)
umb.MovBkwdSpeedInStrafe=1000  #Idem backwards

umb.MaxCombatDist=30000
umb.DistStop=2500.0
umb.DistStopMaxFactor=0.75
umb.DistStop2=8000.0
umb.MaxSeeDist=115000
umb.NaturalWeapons=1

umb.SetNCDSpheres(1)
umb.SetCDSphere(0,-50.0,1400.0)
umb.HeadControlled=0


###############################################################################
#

def UmberhulkWhenFirst():
	Bladex.CreateBipedData("Umb","Umberhulk")
	
	####################################################
	# Uncoment this section only after making changes, #
	# otherwise comment out to speed load times        #
	####################################################
	
	#import os

	#try:
	#	os.remove("..\\..\\AnmPak\\Umb.dat")
	#except:
	#	pass
		
	#####################################################

	exitsPak=Bladex.LoadAnmRaceData("../../AnmPak/Umb.dat")

	import UmberhulkAnimationSet
	UmberhulkAnimationSet.LoadUmberhulkAnimationSet("Umb")
	
	import UmberhulkBAct
	import LinkTables
	LinkTables.LinkMe("Umb")
	import UmberhulkCombos
	import AnmFactUmberhulk
	AnmFactUmberhulk.InitAnmFactUmberhulk()
	import UmberhulkStats
	
	if not exitsPak:
		Bladex.SaveAnmRaceData("../../AnmPak/Umb.dat","Umb")
	
	print"New Umberhulk Data Set"
	
	Bladex.AddFloorCTolerance("slip",10)


		
		
race=Bladex.GetCharType("Umberhulk","Umb")
race.OnFirst=UmberhulkWhenFirst
