import Bladex
import Enm_Def
import Reference
import BCopy
import Combat
import math
import B3DLib
import Actions
import AuxFuncs
import whrandom
import ItemTypes
import Objects
import Damage
import ObjStore
import Basic_Funcs
import Auras
import CharStats
import GameStateAux
import GenFX

import AniSoundUmberhulk




TRUE = 1==1
FALSE = not TRUE

PI = math.pi
TWOPI = PI*2

CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0

ROUTE_WATCH=0  #Watch mode
ROUTE_BAY=1    #Performing a bay route
ROUTE_CHASE=2  #Chase a character
ROUTE_SINGLE=3 #Following a single route (going to just a point)
ROUTE_BOWING=4 #Bowing (OR trying to bow) an enemy



def CheckIfEnemy (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:		
		try:
	           	enemyName=me.Data.EnemyName
	           	return TRUE                       
	        except AttributeError:  
	 	   	return FALSE   

	 	   
def IsHoldingBow(EntityName):
	me=Bladex.GetEntity(EntityName)
	ObjectName=me.InvLeft
	object_flag=Reference.GiveObjectFlag(ObjectName)
	if object_flag==Reference.OBJ_BOW:
		return TRUE
	return FALSE
		
		

Bladex.AddParticleGType("BlueMist","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,128)

for i in range(128):
	if i>64:
		traux=0.0
	else:
		traux=(64.0-i)/64.0
	aux=(128.0-i)/128.0
	r=10
	g=65
	b=220
	a=150.0*(1.0-traux)**0.5
	size=10.0+aux*1200.0
	Bladex.SetParticleGVal("BlueMist",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("UmbLevelUpParticle","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 
		aux=traux**0.5
	else:
		traux=i/25.0 
		aux=traux**2.0
	r=255
	g=255
	b=255
	a=255.0*traux
	size=200.0*aux
	Bladex.SetParticleGVal("UmbLevelUpParticle",i,r,g,b,a,size)


Bladex.AddParticleGType("UmbLifeUpEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,50)

for i in range(50):
	if i>5:
		traux=1.0
		saux=((50.0-i)/45.0)**2.0 
	else:
		saux=traux=i/5.0 
	r=10
	g=120
	b=80
	a=200.0*traux
	size=200.0*saux
	Bladex.SetParticleGVal("UmbLifeUpEnergyConc",i,r,g,b,a,size)




class Umberhulk (Enm_Def.NPCPerson):

	Rfistname=""
	Lfistname=""
	SpikesName=""
	Lforename=""
	Rforename=""
	luzConcRName=""
	luzConcLName=""
	luzAntRName=""
	luzAntLName=""
	rayconcName=""
	luzglowName=""
	rayLName=""
	rayRName=""
	chorigenName=""
	NameOfEnemy=None
	FiringGas=0
	FiringBolt=0
	FiringWobbly=0
	Agenum=0
	BallName=""
	BackShieldName=""
	BackHits=0
	Hibernate=0
	BackAttack=0
	KillCount=0
	DeathFunc=None
	DeathArgs=()
	UmbLevelUpParticleData=[]
	Reyelite=""
	Leyelite=""
	
	
	def __init__(self, me):	
		Enm_Def.NPCPerson.__init__(self, me)

		self.DamageFactorNone  = 0.15
		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.35

		self.Rfistname=""
		self.Lfistname=""
		self.SpikesName=""
		self.Lforename=""
		self.Rforename=""
		self.luzConcRName=""
		self.luzConcLName=""
		self.luzAntRName=""
		self.luzAntLName=""
		self.rayconcName=""
		self.luzglowName=""
		self.rayLName=""
		self.rayLName=""
		self.chorigenName=""
		self.NameOfEnemy=None
		self.FiringGas=0
		self.FiringBolt=0
		self.FiringWobbly=0
		self.Agenum=0
		self.BallName=""
		self.BackShieldName=""
		self.BackHits=0
		self.Hibernate=0
		self.BackAttack=0
		self.KillCount=0
		self.DeathFunc=None
		self.DeathArgs=()
		self.UmbLevelUpParticleData=[]
		self.Reyelite=""
		self.Leyelite=""
		
		
		me.AddAnmEventFunc("Start_LFistWeapon", self.StartLFist)
		me.AddAnmEventFunc("Stop_LFistWeapon", self.StopLFist)
		
		me.AddAnmEventFunc("Start_RForeWeapon", self.StartRFore)
		me.AddAnmEventFunc("Stop_RForeWeapon", self.StopRFore)
		
		me.AddAnmEventFunc("Start_Spikes", self.StartSpikes)
		me.AddAnmEventFunc("Stop_Spikes", self.StopSpikes)
		
		me.AddAnmEventFunc("AimBolt", self.Aim)
		me.AddAnmEventFunc("FireBolt", self.Fire)
		
		me.AddAnmEventFunc("HitGoundEvent", self.HitTheDust)
		
		inv = me.GetInventory()
		inv.maxWeapons = 5
		
		me.ImDeadFunc=self.NUImDeadFunc

		self.lectricsnd=Bladex.CreateSound("..\\..\\Sounds\\M-CAMPO-MAG.wav", "ElectricSound1")
		self.lectricsnd.Volume=1.0
		self.lectricsnd.MinDistance=10000
		self.lectricsnd.MaxDistance=30000
		
		self.fartsound=Bladex.CreateSound("..\\..\\Sounds\\FireBall-Fire.wav", "FartSound")
		self.fartsound.Volume=1.0
		self.fartsound.MinDistance=10000
		self.fartsound.MaxDistance=30000
		
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.UmbLevelUpParticleData.append(a)
			self.UmbLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("UmbLevelUpParticle",i,r,g,b,a,size)

	
		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		self.MakeFists()



	def ResetSounds(self, EntityName):
		AniSoundUmberhulk.AsignarSonidosUmberhulk(EntityName)
		Bladex.ReadBitMap("../../Maps/DwarfWarsII/NUFiles/NULesserDemonStuff/UmberhulkIcon.bmp","UmberhulkIcon")
		Reference.EnemiesScorerData[self.Name]=("UmberhulkIcon","Umb")	
		
		
	def StdEnterClose(self,EntityName):
		Reference.debugprint(EntityName+": I am entering close combat")
		pass
	
	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		me=Bladex.GetEntity(EntityName)
		if self.Asleep:
			self.WakeMeUp(EntityName)
		if AttackerName:
			print EntityName+" Ooooowwww!!"
			if me.Life<=0:
				return
			if IsHoldingBow(AttackerName):
				print EntityName+" My Enemy is an Archer"
				return
			if Actions.IsBehindEntity(AttackerName, EntityName):
				print "Attacked from behind by",AttackerName
				if not self.BackAttack:
					Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,self.LaunchBackAttack,(EntityName,))
					
			attacker = Bladex.GetEntity(AttackerName)
			maxlife=CharStats.GetCharMaxLife(me.Kind, me.Level)
			if DamagePoints> 100:
				if self.NameOfEnemy and self.NameOfEnemy != AttackerName:
					if attacker and attacker.Kind != me.Kind:
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							self.NameOfEnemy=attacker.Name
							me.Chase(attacker, me.ActionAreaMax)
									
				
	def HitTheDust(self,EntityName,EventName):
		me=Bladex.GetEntity(EntityName)
		x,y,z= me.GraspPos("ViewPoint")
		polvillo=Bladex.CreateEntity("PolvoGolpe", "Entity Particle System D1", x,y,z)
		polvillo.ParticleType="MediumDust"
		polvillo.YGravity=200
		polvillo.Friction=0.2
		polvillo.PPS=200
		polvillo.DeathTime=Bladex.GetTime()+2.0/60.0
		polvillo.Velocity=0, -1000, 0
		polvillo.RandomVelocity=40.0
		
				
	def Deactivate(self):
		me=Bladex.GetEntity(self.Name)
		self.Hibernate=1
		if me.Life<=0:
			return
		if self.Reyelite:
			reyelite=Bladex.GetEntity(self.Reyelite)
			AuxFuncs.SpotIntensityVariation(self.Reyelite, 0.2, 0.0, 1.0)
			
		if self.Leyelite:
			leyelite=Bladex.GetEntity(self.Leyelite)
			AuxFuncs.SpotIntensityVariation(self.Leyelite, 0.2, 0.0, 1.0)
			
		
	def Activate(self):
		me=Bladex.GetEntity(self.Name)
		self.Hibernate=0
		if me.Life<=0:
			return
		if self.Reyelite:
			reyelite=Bladex.GetEntity(self.Reyelite)
			AuxFuncs.SpotIntensityVariation(self.Reyelite, 0.0, 0.2, 1.0)
		if self.Leyelite:
			leyelite=Bladex.GetEntity(self.Leyelite)
			AuxFuncs.SpotIntensityVariation(self.Leyelite, 0.0, 0.2, 1.0)
		
		
		
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Alpha<0.9:
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		
		if  CheckIfEnemy(entity.Name): 
			return TRUE
		else:
			return FALSE
		
		
	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)
		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

		
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.NameOfEnemy or Bladex.GetEntity(self.NameOfEnemy).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		char=Bladex.GetEntity("Player1")
                   		if me.CanISee(char):
	  				self.NameOfEnemy="Player1"
                   			enemy=Bladex.GetEntity(self.NameOfEnemy)
                			me.SetEnemy(enemy)
					return self.NameOfEnemy			
                   		else:
                   			return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.NameOfEnemy=enemyList[0]
		enemy=Bladex.GetEntity(self.NameOfEnemy)
                me.SetEnemy(enemy)
		return self.NameOfEnemy					
		
		
		
	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if self.Hibernate:
			print EntityName+": I am comatose"
			return
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			Reference.debugprint (EntityName + ": I spy a GOOD guy")
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					Reference.debugprint (EntityName + ": Your Name is "+ene.Name+ " I will do you over")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Enm_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Enm_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				
	def OnKilledEnemy(self,KilledEntityName):
		print "Umberhulk Killed something"
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		me=Bladex.GetEntity(self.Name)
		self.KillCount=self.KillCount+1
		#print "Kill Count is: ",self.KillCount
		if self.KillCount%7==0:
			print "Umberhulk Leveling up"
			me.Level=me.Level+1
			if me.Life >0: 
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
				self.UMBLUP1()
				
		
		
		
	def UMBLUP2(self):
		AuraParams=(5, 0, 1, 0, 0, 1)
		AuraGradient=(2, 1.0, 0.4, 0.2, 0.5, 0.0, 1.0, 0.15, 0.04, 0.0, 0.8)
		AuraVar1Args=(5, 200, 0, 1, 1.0)
		AuraVar2Args=(200, 5, 1, 0, 1.5)
		PSParams=(self.UmbLevelUpParticleData, "UmbLevelUpParticle", 30, 255, 40, 10, 400, -600, 0.0, 2, 2, 0.4, 30, 1.6)
		GenFX.LevelUpFX(self.Name, 0, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, 4.0, "Timer15", 15, "..\\..\\Sounds\\aparicion-espada.wav")
		
		#list_of_nodes=("Head", "L_Shoulder", "L_Elbow", "L_Hand", "R_Shoulder", "R_Elbow", "R_Hand", "Center", "L_Knee", "L_Foot", "R_Knee", "R_Foot")
		#GenFX.ElectricDischarge(self.Name, "DGRayLevelUp", 255, 40, 10, 600, list_of_nodes, 10, 1.5)

	def UMBLUP1(self):
		pslup=Bladex.CreateEntity("PSDGLifeUp", "Entity Particle System Dperson", 0, 0, 0)
		pslup.PersonName=self.Name
		pslup.ParticleType="UmbLifeUpEnergyConc"
		pslup.PPS=400
		pslup.YGravity=0
		pslup.Friction=0.0
		pslup.RandomVelocity=-2
		pslup.NormalVelocity=-20
		pslup.FollowFactor=0.0
		pslup.Time2Live=50
		pslup.Velocity=0.0, 0.0, 0.0
		pslup.DeathTime=Bladex.GetTime()+1.0
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.6, self.UMBLUP2, ())
		
		
			
			
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if (not self.Asleep) and (not me.Blind):
				if me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
				me.StopLooking()
				self.PutMeToSleep(EntityName)
				#if not self.NameOfEnemy:
				self.LookForAnotherOpponent(EntityName)
				Reference.debugprint(EntityName+": I have got bored and dropped to sleep")







	def LookForAnotherOpponent(self,EntityName):
		Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		#self.LaunchMyWatch (EntityName)
		mep=me.Position
		enelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 20000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					enelist.append(en.Name)
		if len (enelist) == 0: 
                   	return 
                enelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(enelist[0])
                if nearest:
                	dist=B3DLib.GetXZDistance(EntityName, nearest.Name)
                	Actions.QuickTurnToFaceEntity(EntityName, nearest.Name)
                	if dist>6000 and not me.CanISee(nearest):
                		me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
				me.RouteEndedFunc=self.LaunchMyWatch
				print EntityName+" I have found a new enemy and I am going to sort the bugger out "
	
	
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if not entity.Person: 
			return FALSE
		if not entity.Life > 0:
			return FALSE
		if entity.Alpha<0.9:
			return FALSE
		if entity.Name == self.Name:
			return FALSE
		if entity.Kind==me.Kind:
			return FALSE
		if IsHoldingBow(entity.Name):
			return FALSE
		if  CheckIfEnemy(entity.Name): 
			return TRUE
		else:
			return FALSE
			

	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)
		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER
			
			
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			me.Deaf=1
			self.Asleep = TRUE


	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			me.Deaf=0
			self.Asleep = FALSE						
					
					
					
					
					
								
	########### Back Attack ####
	
	def RecoverFlame(self):
		self.BackAttack=0
	
	
	def LaunchBackAttack(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		x,y,z=me.GraspPos("Ahole")
		if self.BackAttack:
			return
		self.BackAttack=1
		duration= 0.3
		self.Agenum=self.Agenum+1
		end_time=Bladex.GetTime()+duration
		period= duration/10.0
		fireball=Bladex.CreateEntity(EntityName+"_FlameFart_"+`self.Agenum`,"Entity Particle System D1",x,y,z)
		fireball.ParticleType="Flame"######
		fireball.Time2Live=20
		fireball.YGravity=-4900.0
		fireball.Friction=0.12
		fireball.PPS=512
		fireball.DeathTime=end_time
		#F= 5400.0             # Vector magnitude
		vx,vy,vz=me.Rel2AbsVector(0,10000,-1500)  #(X,Y,Z)
		fireball.Velocity=vx,vy,vz
		fireball.RandomVelocity=55.0
		self.FlameFartFunc(fireball.Name, end_time, period)
		Bladex.AddScheduledFunc(Bladex.GetTime()+8,self.RecoverFlame,())
		sound_pos=me.Position
		self.fartsound.Play(sound_pos[0], sound_pos[1], sound_pos[2], 0)
		print"let one go"
		
		
	def FlameFartFunc(self, fireball_name,end_time,period):
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FireFartPrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.FlameFartFunc,(fireball_name,end_time,period))		
	
	
	def FireFartPrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Umberhulk":
					me=Bladex.GetEntity(self.Name)
					lvl=me.Level+6
					firepow=lvl*lvl
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,   1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +firepow]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						Damage.DropInvalidObjectsOnImpact (victim.Name)
						victim.Wuea=Reference.WUEA_ENDED
						if victim.InCombat: 
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else: 
							victim.LaunchAnmType("hurt_f_big")
							
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()	
	
	
		
	##### Range Attacks #######	
	
		
	# Select attack according to enemy distance
	
	def Aim(self,EntityName,EventName):
		if self.FiringBolt or self.FiringGas or self.FiringWobbly:
			print "No Attack, already firing"
			return
		me = Bladex.GetEntity(EntityName)
		ene=Bladex.GetEntity(self.NameOfEnemy)
		if not ene:
			return
		dist=B3DLib.GetXZDistance(EntityName, ene.Name)
		if dist<5000:
			self.FiringGas=1
			print "aiming gas cloud now"
			pass
		elif dist>=5000 and dist <10000:
			self.AimMyBolt(EntityName)
			self.FiringBolt=1
			print "Aiming Bolts"
		else:
			self.AimWobbly(EntityName)
			self.FiringWobbly=1
			print "Aiming wobbly"
			
		
			
			
	def Fire(self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if self.FiringBolt:
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.45, self.FireMyBolt,(EntityName,))
		elif self.FiringGas:
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.10, self.FireGas1,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.35, self.FireGas2,(EntityName,))
		elif self.FiringWobbly:
			self.FireMyWobbly(EntityName)
			
			
		
	## Gas
	
	def FireGas1 (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			if self.NameOfEnemy:
				Actions.QuickTurnToFaceEntity (EntityName, self.NameOfEnemy)
			
	
	
	def FireGas2 (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			# Get an angle to the target
			if self.NameOfEnemy:
				target= Bladex.GetEntity(self.NameOfEnemy)
			else:
				return
			target_pos= target.Position
			x,y,z= me.GraspPos("Mouth")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			duration= 0.3
			self.Agenum=self.Agenum+1
			end_time=Bladex.GetTime()+duration
			period= duration/10.0
			fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.Agenum`,"Entity Particle System D1",x,y,z)
			fireball.ParticleType="BlueMist"      
			fireball.Time2Live=20
			fireball.YGravity=-500.0
			fireball.Friction=0.12
			fireball.PPS=512
			fireball.DeathTime=end_time;
			F= 7000.0             # Vector magnitude
			vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
			fireball.Velocity=vx,vy,vz
			fireball.RandomVelocity=55.0
			node= me.GetNodeIndex("Head")
			me.LinkToNode(fireball,node)
			self.SpitFunc(fireball.Name, end_time, period)		
			self.FiringGas=0
				
		
		
	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Umberhulk":
					me=Bladex.GetEntity(self.Name)
					lvl=me.Level+1
					firepow=lvl
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +firepow]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Venom", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						if victim.InCombat:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()





	def SpitFunc(self, fireball_name,end_time,period):		
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period))
				
		
		
	## Wobbly
	
	def AimWobbly (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if self.luzAntRName:
			luzantR=Bladex.GetEntity(self.luzAntRName).SubscribeToList("Pin")
		if self.luzAntLName:
			luzantL=Bladex.GetEntity(self.luzAntLName).SubscribeToList("Pin")
		head_idx=me.GetNodeIndex("Head")
		if me and me.Life>0:
			rx,ry,rz=me.GraspPos("RAntenna")
			luzantR=Bladex.CreateEntity("RLuzAntRayoWobbly", "Entity Spot", rx, ry, rz)
			luzantR.Color=0, 80, 100
			luzantR.Intensity=0.0
			luzantR.Precission=0.001
			luzantR.CastShadows=0
			luzantR.Visible=0
			self.luzAntRName= luzantR.Name
			me.LinkToNode(luzantR, head_idx)
		
			lx,ly,lz=me.GraspPos("LAntenna")
			luzantL=Bladex.CreateEntity("LLuzAntRayoWobbly", "Entity Spot", lx, ly, lz)
			luzantL.Color=0, 80, 100
			luzantL.Intensity=0.0
			luzantL.Precission=0.001
			luzantL.CastShadows=0
			luzantL.Visible=0
			self.luzAntLName= luzantL.Name
			me.LinkToNode(luzantL, head_idx)
			fadetime=1.0
			AuxFuncs.SpotIntensityVariation(luzantR.Name, 0.0, 4.0, fadetime)
			AuxFuncs.SpotIntensityVariation(luzantL.Name, 0.0, 4.0, fadetime)
			Bladex.AddScheduledFunc(Bladex.GetTime()+fadetime+0.1,self.AimWobbly2,(EntityName,))
			
			
	def AimWobbly2(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		x,y,z=me.GraspPos("Wobbly")
		self.Agenum= self.Agenum+1
		if not self.NameOfEnemy or Bladex.GetEntity(self.NameOfEnemy).Life<=0:
			self.MyGetEnemyName()	
		ball=MakeSmallWobblyBall(EntityName+"_Ball"+`self.Agenum`, x,y,z, EntityName,self.NameOfEnemy)
		print "BigGuy set wobbly target to: ", self.NameOfEnemy
		ball.Velocity= me.Rel2AbsVector(0.0, -250.0, 250.0)
		self.BallName= ball.Name
		
			
	def ResetWobblyVar(self):
		self.FiringWobbly=0
			
			
			
			
	def FireMyWobbly (self,EntityName):
		ball= Bladex.GetEntity(self.BallName)
		print "fireing WOBBBBBBBBBBBBBLY"
		if self.luzAntRName:
			AuxFuncs.SpotIntensityVariation(self.luzAntRName, 4.0, 0.0, 1.0, 1)
			self.luzAntRName= None
			print "R ant lite fading"
		if self.luzAntLName:
			AuxFuncs.SpotIntensityVariation(self.luzAntLName, 4.0, 0.0, 1.0, 1)
			self.luzAntLName= None
			print "L ant lite fading"
		if ball:
			ball.Data.ReleaseThrownWeaponHandler(self.BallName, "")	
			print "Wobbly Gone"
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.1,self.ResetWobblyVar,())
			
			
		
		
	## Laser
		
	def AimMyBolt(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		self.StopLaser(EntityName)
		head_idx=me.GetNodeIndex("Head")
		
		rx,ry,rz=me.GraspPos("RMandible")
		luzconcR=Bladex.CreateEntity("RLuzConcRayoLaser", "Entity Spot", rx, ry, rz)
		luzconcR.Color=140, 180, 255
		luzconcR.Intensity=0.0
		luzconcR.Precission=0.001
		luzconcR.CastShadows=0
		luzconcR.Visible=0
		self.luzConcRName= luzconcR.Name
		me.LinkToNode(luzconcR, head_idx)
		
		lx,ly,lz=me.GraspPos("LMandible")
		luzconcL=Bladex.CreateEntity("LLuzConcRayoLaser", "Entity Spot", lx, ly, lz)
		luzconcL.Color=140, 180, 255
		luzconcL.Intensity=0.0
		luzconcL.Precission=0.001
		luzconcL.CastShadows=0
		luzconcL.Visible=0
		self.luzConcLName= luzconcL.Name
		me.LinkToNode(luzconcL, head_idx)
		
		
		mx,my,mz=me.GraspPos("Mouth") # Space between mandibles
		rayconc=Bladex.CreateEntity("PSConcRayoLaser","Entity Particle System D1", mx, my, mz)
		rayconc.ParticleType="LittleBlueEnergyConc"
		rayconc.FollowFactor=1.0
		rayconc.YGravity=0
		rayconc.RandomVelocity=-10
		rayconc.Velocity=me.Rel2AbsVector(0.0, 600.0, 0.0, "Head")
		rayconc.Time2Live=30
		rayconc.PPS=200
		me.LinkToNode(rayconc, head_idx)
		self.rayconcName= rayconc.Name
		
		luzglow=Bladex.CreateEntity("LuzGlowRayoLaser", "Entity Spot", mx, my, mz)
		luzglow.Color=10, 20, 50
		luzglow.Intensity=0.0
		luzglow.CastShadows=0
		me.LinkToNode(luzglow, head_idx)
		self.luzglowName= luzglow.Name
		AuxFuncs.SpotIntensityVariation(luzglow.Name, 0.0, 0.01, 3.0, 0, 0.0, 1.5)
		AuxFuncs.SpotIntensityVariation(luzconcL.Name, 0.0, 4.0, 3.0)
		AuxFuncs.SpotIntensityVariation(luzconcR.Name, 0.0, 4.0, 3.0)
		Bladex.RemoveScheduledFunc(EntityName+"StopLaserFunc")
		TimeToStop=5.0 # has to be enough time to get to FireLaser() normally
		Bladex.AddScheduledFunc(Bladex.GetTime()+TimeToStop, self.StopLaser, (EntityName,), EntityName+"StopLaserFunc")
		
		
		
		
	def StopLaser (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		print "StopLaser"
		if self.luzConcRName:
			AuxFuncs.SpotIntensityVariation(self.luzConcRName, 4.0, 0.0, 1.0, 1)
			self.luzConcRName= None
		if self.luzConcLName:
			AuxFuncs.SpotIntensityVariation(self.luzConcLName, 4.0, 0.0, 1.0, 1)
			self.luzConcLName= None
		if self.luzglowName:
			AuxFuncs.SpotIntensityVariation(self.luzglowName, 0.01, 0.0, 1.0, 1, 1.5, 0.0)
			self.luzglowName= None
		if self.rayconcName:
			rayconc= Bladex.GetEntity(self.rayconcName)
			if rayconc: rayconc.DeathTime=Bladex.GetTime()
			self.rayconcName= None
		if self.chorigenName:
			chorigen= Bladex.GetEntity(self.chorigenName)
			if chorigen: chorigen.DeathTime=Bladex.GetTime()
			self.chorigenName= None
			
		if self.rayLName:
			rayL= Bladex.GetEntity (self.rayLName)
			if rayL:
				me.Unlink(rayL)
				rayL.Active= 0
				rayL.SubscribeToList("Pin")
			self.rayLName= None
	
		if self.rayRName:
			rayR= Bladex.GetEntity (self.rayRName)
			if rayR:
				me.Unlink(rayR)
				rayR.Active= 0
				rayR.SubscribeToList("Pin")
			self.rayRName= None
		self.FiringBolt=0
		self.lectricsnd.Stop()
		
		
		
	def RecalibrateLaserFunc (self,EntityName, TimeToStop,Period):
		if not self.rayLName or not self.rayRName:    
			return
		me = Bladex.GetEntity(EntityName)
		
		rayL= Bladex.GetEntity (self.rayLName)
		rayR= Bladex.GetEntity (self.rayRName)
		
		if not me or not rayL or not rayR:  
			return
		if me.Life < 0:
			self.StopLaser (EntityName)
	
		x,y,z= me.GraspPos("ViewPoint")		
		ox,oy,oz=me.Rel2AbsVector(0, 0, 50, "Head")
		x= x+ox; y= y+oy; z= z+oz
		target=Bladex.GetEntity(self.NameOfEnemy)
		if not target:
			return
	
		tx,ty,tz= target.Position
		angle= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		distance= 1000.0 + math.sqrt(((tx-x)*(tx-x))+((ty-y)*(ty-y))+((tz-z)*(tz-z)))
		vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*distance, -math.sin(angle)*distance)
		tx= x+vx; ty= y+vy; tz= z+vz
	
		rayL.Target= tx,ty,tz
		rayR.Target= tx,ty,tz
		Actions.QuickTurnToFaceEntity (EntityName, self.NameOfEnemy)
	
		next_call_time= Bladex.GetTime() + Period 
		if next_call_time < TimeToStop:
			Bladex.AddScheduledFunc(next_call_time, self.RecalibrateLaserFunc, (EntityName,TimeToStop,Period), "RecalibrateLaserFunc")
		else:
			Bladex.RemoveScheduledFunc(EntityName+"StopLaserFunc")
			Bladex.AddScheduledFunc(TimeToStop, self.StopLaser, (EntityName,), EntityName+"StopLaserFunc")

		
		
	def FireMyBolt(self,EntityName):
		print "FireLaser"
		Bladex.RemoveScheduledFunc(EntityName+"StopLaserFunc")
		me = Bladex.GetEntity(EntityName)
		try:
			if self.rayLName or self.rayRName:
				self.StopLaser(EntityName)
		except AttributeError:
			pass
		if self.rayconcName:
			rayconc=Bladex.GetEntity(self.rayconcName)
			if rayconc:
				rayconc.RandomVelocity=-4
				rayconc.Velocity=0.0, 0.0, 0.0
				rayconc.PPS=100
		lvl=me.Level+1
		ldam=lvl*10
		head_idx=me.GetNodeIndex("Head")
		x,y,z= me.GraspPos("Mouth")########
		ox,oy,oz=me.Rel2AbsVector(0, 0, 0, "Head")
		x= x+ox; y= y+oy; z= z+oz
		chorigen=Bladex.CreateEntity("ChispasOrigenRayoLaser","Entity Particle System D1", x, y, z)
		chorigen.ParticleType="BlueSpark"
		chorigen.FollowFactor=1.0
		chorigen.YGravity=0
		chorigen.RandomVelocity=30
		chorigen.Velocity=me.Rel2AbsVector(0.0, -1000.0, 0.0, "Head")
		chorigen.Time2Live=6
		chorigen.PPS=800
		me.LinkToNode(chorigen, head_idx)
		self.chorigenName=chorigen.Name
		
		target=Bladex.GetEntity(self.NameOfEnemy)
		tx,ty,tz= target.Position
		angle= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		distance= 1000.0 + math.sqrt(((tx-x)*(tx-x))+((ty-y)*(ty-y))+((tz-z)*(tz-z)))
		vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*distance, -math.sin(angle)*distance)
		tx= x+vx; ty= y+vy; tz= z+vz
	
		x,y,z= me.GraspPos("LMandible")
		ox,oy,oz=me.Rel2AbsVector(-50, 0, 0, "Head")
		x= x+ox 
		y= y+oy 
		z= z+oz
		rayL= Bladex.CreateEntity("RayL", "Entity ElectricBolt", x,y,z)
		Reference.EntitiesObjectData[rayL.Name]=[Reference.OBJ_WEAPON,    0,  0, 1.0,  Reference.THR_STRAIGHT, [], ['Light', +ldam]]
		rayL.FixedTarget= FALSE
		rayL.MaxAmplitude=500.0
		me.LinkToNode(rayL, head_idx)
		rayL.Position= x,y,z	# The position gets screwed up after linking
		rayL.Target= tx,ty,tz
		rayL.Active= 1
		self.rayLName= rayL.Name
	
		x,y,z= me.GraspPos("RMandible")		
		ox,oy,oz=me.Rel2AbsVector(50, 0, 0, "Head")
		x= x+ox 
		y= y+oy 
		z= z+oz
		rayR= Bladex.CreateEntity("RayR", "Entity ElectricBolt", x,y,z)
		Reference.EntitiesObjectData[rayR.Name]=[Reference.OBJ_WEAPON,    0,  0, 1.0,  Reference.THR_STRAIGHT, [], ['Light', +ldam]]
		rayR.FixedTarget= FALSE
		rayR.MaxAmplitude=500.0
		me.LinkToNode(rayR, head_idx)
		rayR.Position= x,y,z	# The position gets screwed up after linking
		rayR.Target= tx,ty,tz
		rayR.Active= 1
		self.rayRName= rayR.Name
		me.AnmEndedFunc=self.StopLaser
		Bladex.RemoveScheduledFunc("StopLaserFunc")
		time= Bladex.GetTime()
		period= 0.2
		Bladex.AddScheduledFunc(time+period, self.RecalibrateLaserFunc, (EntityName,time+4.0,period), "RecalibrateLaserFunc")
		self.lectricsnd.Play(x,y,z,-1)
		
		
		
	######## extra weapons handlers
		
	def StartSpikes(self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if self.SpikesName:
			spikes=Bladex.GetEntity(self.SpikesName)
			spikes.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		
	def StopSpikes(self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		if self.SpikesName:
			spikes=Bladex.GetEntity(self.SpikesName)
			spikes.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		
		
		
		
		
	def StartLFist(self,EntityName,EventName):
		if self.Lfistname:
			lfist=Bladex.GetEntity(self.Lfistname)
			lfist.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		if self.Lforename:
			lfore=Bladex.GetEntity(self.Lforename)
			lfore.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		
	def StopLFist(self,EntityName,EventName):
		if self.Lfistname:
			lfist=Bladex.GetEntity(self.Lfistname)
			lfist.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		if self.Lforename:
			lfore=Bladex.GetEntity(self.Lforename)
			lfore.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)


	def StartRFore(self,EntityName,EventName):
		if self.Rforename:
			rfore=Bladex.GetEntity(self.Rforename)
			rfore.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		
	def StopRFore(self,EntityName,EventName):
		if self.Rforename:
			rfore=Bladex.GetEntity(self.Rforename)
			rfore.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)



	### Tool up #####
	
	def SetMyDamage(self):
		me = Bladex.GetEntity(self.Name)
		lvl=me.Level+12
		dam=lvl*lvl
		Reference.EntitiesObjectData[self.Name]=Reference.DefaultObjectData[me.Kind]
		Reference.EntitiesObjectData[self.Name][1]=dam
		if self.Rfistname:
			Reference.EntitiesObjectData[self.Rfistname][1]=dam
		if self.Lfistname:
			Reference.EntitiesObjectData[self.Lfistname][1]=dam
		if self.SpikesName:
			Reference.EntitiesObjectData[self.SpikesName][1]=dam
		if self.Lforename:
			Reference.EntitiesObjectData[self.Lforename][1]=dam
		if self.Rforename:
			Reference.EntitiesObjectData[self.Rforename][1]=dam
		

	def MakeFists(self):
		me = Bladex.GetEntity(self.Name)
		inv=me.GetInventory()
		rfist=Bladex.CreateEntity(self.Name+"RightFist","UmberhulkFist",0,0,0,"Weapon")
		lfist=Bladex.CreateEntity(self.Name+"LeftFist","UmberhulkFist",0,0,0,"Weapon")
		spikes=Bladex.CreateEntity(self.Name+"SpikyBits","Uspikes",0,0,0,"Weapon")
		lfore=Bladex.CreateEntity(self.Name+"LeftForearm","UmberhulkFist",0,0,0,"Weapon")
		rfore=Bladex.CreateEntity(self.Name+"RightForearm","UmberhulkFist",0,0,0,"Weapon")
		Reference.EntitiesObjectData[rfist.Name]=Reference.DefaultObjectData[rfist.Kind]
		Reference.EntitiesObjectData[lfist.Name]=Reference.DefaultObjectData[lfist.Kind]
		Reference.EntitiesObjectData[spikes.Name]=Reference.DefaultObjectData[spikes.Kind]
		Reference.EntitiesObjectData[lfore.Name]=Reference.DefaultObjectData[lfore.Kind]
		Reference.EntitiesObjectData[rfore.Name]=Reference.DefaultObjectData[rfore.Kind]
		self.Rfistname=rfist.Name
		self.Lfistname=lfist.Name
		self.SpikesName=spikes.Name
		self.Lforename=lfore.Name
		self.Rforename=rfore.Name
		rfist.Scale=1.2
		rfist.Alpha=0.0
		rfist.CastShadows=0
		rfist.RasterMode  ="AdditiveAlpha"
		rfist.RasterMode  ="Read"
		inv.AddWeapon(rfist.Name)
		inv.LinkRightHand(rfist.Name)	
		lfist.Scale=1.2
		lfist.Alpha=0.0
		lfist.CastShadows=0
		lfist.RasterMode  ="AdditiveAlpha"
		lfist.RasterMode  ="Read"
		inv.AddWeapon(lfist.Name)
		# Don't link to L_Hand Anchor or maybe he thinks he has a shield.....
		me.LinkAnchors("L_Fist",lfist,"1H_L")
		spikes.Alpha=0.0
		spikes.CastShadows=0
		spikes.RasterMode  ="AdditiveAlpha"
		spikes.RasterMode  ="Read"
		inv.AddWeapon(spikes.Name)
		me.LinkAnchors("Mouth",spikes,"1H_R")
		lfore.Scale=0.9
		lfore.Alpha=0.0
		lfore.CastShadows=0
		lfore.RasterMode  ="AdditiveAlpha"
		lfore.RasterMode  ="Read"
		inv.AddWeapon(lfore.Name)
		me.LinkAnchors("L_Fore",lfore,"1H_R")
		rfore.Scale=0.9
		rfore.Alpha=0.0
		rfore.CastShadows=0
		rfore.RasterMode  ="AdditiveAlpha"
		rfore.RasterMode  ="Read"
		inv.AddWeapon(rfore.Name)
		me.LinkAnchors("R_Fore",rfore,"1H_R")
		self.SetMyDamage()
		head_idx=me.GetNodeIndex("Head")
		lojox,lojoy,lojoz=me.GraspPos("Leye")
		rojox,rojoy,rojoz=me.GraspPos("Reye")
		leyelite=Bladex.CreateEntity(self.Name+"LeftEyeLite","Entity Spot",lojox,lojoy,lojoz)
		reyelite=Bladex.CreateEntity(self.Name+"RightEyeLite","Entity Spot",rojox,rojoy,rojoz)
		self.Reyelite=reyelite.Name
		self.Leyelite=leyelite.Name
		me.LinkToNode(reyelite, head_idx)
		me.LinkToNode(leyelite, head_idx)
		reyelite.Color=140, 10, 10
		reyelite.Intensity=0.1
		reyelite.Precission=0.001
		reyelite.CastShadows=0
		reyelite.Visible=1
		leyelite.Color=140, 10, 10
		leyelite.Intensity=0.1
		leyelite.Precission=0.001
		leyelite.CastShadows=0
		leyelite.Visible=1
		
		
		
	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=TRUE
			self.AttackNPCTime = 100.0
			me.BlockingPropensity = 0.2
			me.AttackList = BCopy.deepcopy(UmberhulkAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
		

	def NUImDeadFunc (self,EntityName):
		print "Umberhulk Slain"
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
			print "Umberhulk DeathFunc applied"
		me = Bladex.GetEntity(EntityName)
		inv=me.GetInventory()
		me.Wuea=Reference.WUEA_ENDED
		me.SetTmpAnmFlags(1,1,1,0,5,1)
		me.LaunchAnimation("Umb_dth01")	
		
		if self.Rfistname:
			rfist=Bladex.GetEntity(self.Rfistname)
			Actions.RemoveFromInventory(me, rfist,"DropRightEvent")
			rfist.Alpha=0.0
			rfist.Position=0,50000,0
		if self.Lfistname:
			lfist=Bladex.GetEntity(self.Lfistname)
			Actions.RemoveFromInventory(me, lfist,"")
			lfist.Alpha=0.0
			lfist.Position=0,50000,0
		if self.SpikesName:
			spikes=Bladex.GetEntity(self.SpikesName)
			Actions.RemoveFromInventory(me, spikes,"")
			spikes.Alpha=0.0
			spikes.Position=0,50000,0
		if self.Lforename:
			lfore=Bladex.GetEntity(self.Lforename)
			Actions.RemoveFromInventory(me, lfore,"")
			lfore.Alpha=0.0
			lfore.Position=0,50000,0
		if self.Rforename:
			rfore=Bladex.GetEntity(self.Rforename)
			Actions.RemoveFromInventory(me, rfore,"")
			rfore.Alpha=0.0
			rfore.Position=0,50000,0		
		if self.Reyelite:
			AuxFuncs.SpotIntensityVariation(self.Reyelite, 0.1, 3.0, 1.0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.3,AuxFuncs.SpotIntensityVariation,(self.Reyelite, 3.0, 0.0, 5.0,))
		if self.Leyelite:
			AuxFuncs.SpotIntensityVariation(self.Leyelite, 0.1, 3.0, 1.0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.4,AuxFuncs.SpotIntensityVariation,(self.Leyelite, 3.0, 0.0, 5.0,))
		print "Umberhulk Slain Completely"
		
		


			
		
	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["Umberhulk"]=(self.Rfistname,
		                                 self.Lfistname,
		                                 self.SpikesName,
						 self.Lforename,
						 self.Rforename,
						 self.luzConcRName,
						 self.luzConcLName,
						 self.luzAntRName,
						 self.luzAntLName,
						 self.rayconcName,
						 self.luzglowName,
						 self.rayLName,
						 self.rayLName,
						 self.chorigenName,
						 self.NameOfEnemy,
						 self.FiringGas,
						 self.FiringBolt,
						 self.FiringWobbly,
						 self.Agenum,
						 self.BallName,
						 self.Hibernate,
						 self.BackAttack,
		                                 self.KillCount,
		            			 GameStateAux.SaveFunctionAux(self.DeathFunc),
		                                 self.DeathArgs,
		                                 self.Reyelite,
						 self.Leyelite)
						 
		return NPCPerson_state
	
	
	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Umberhulk"]
			self.Rfistname=parms[0]
			self.Lfistname=parms[1]
			self.SpikesName=parms[2]
			self.Lforename=parms[3]
			self.Rforename=parms[4]
			self.luzConcRName=parms[5]
			self.luzConcLName=parms[6]
			self.luzAntRName=parms[7]
			self.luzAntLName=parms[8]
			self.rayconcName=parms[9]
			self.luzglowName=parms[10]
			self.rayLName=parms[11]
			self.rayLName=parms[12]
			self.chorigenName=parms[13]
			self.NameOfEnemy=parms[14]
			self.FiringGas=parms[15]
			self.FiringBolt=parms[16]
			self.FiringWobbly=parms[17]
			self.Agenum=parms[18]
			self.BallName=parms[19]
			self.Hibernate=parms[20]
			self.BackAttack=parms[21]
		        self.KillCount=parms[22]
		        GameStateAux.LoadFunctionAux(parms[23],self,"DeathFunc")
		        self.DeathArgs=parms[24]
		        self.Reyelite=parms[25]
			self.Leyelite=parms[26]
			
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Start_LFistWeapon", self.StartLFist)
		me.AddAnmEventFunc("Stop_LFistWeapon", self.StopLFist)
		
		me.AddAnmEventFunc("Start_RForeWeapon", self.StartRFore)
		me.AddAnmEventFunc("Stop_RForeWeapon", self.StopRFore)
		
		me.AddAnmEventFunc("Start_Spikes", self.StartSpikes)
		me.AddAnmEventFunc("Stop_Spikes", self.StopSpikes)
		
		me.AddAnmEventFunc("AimBolt", self.Aim)
		me.AddAnmEventFunc("FireBolt", self.Fire)
		
		me.AddAnmEventFunc("HitGoundEvent", self.HitTheDust)
		
		inv = me.GetInventory()
		inv.maxWeapons = 5
		
		me.ImDeadFunc=self.NUImDeadFunc
		
		self.UmbLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.UmbLevelUpParticleData.append(a)
			self.UmbLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("UmbLevelUpParticle",i,r,g,b,a,size)

		self.lectricsnd=Bladex.CreateSound("..\\..\\Sounds\\M-CAMPO-MAG.wav", "ElectricSound1")
		self.lectricsnd.Volume=1.0
		self.lectricsnd.MinDistance=10000
		self.lectricsnd.MaxDistance=30000
		
		self.fartsound=Bladex.CreateSound("..\\..\\Sounds\\FireBall-Fire.wav", "FartSound")
		self.fartsound.Volume=1.0
		self.fartsound.MinDistance=10000
		self.fartsound.MaxDistance=30000
		
		
		
		
		
UmberhulkAttackData = [
            #[Combat.ATTACK,  0.25, ("g_01",),          1000.0, 2000.0, 3500.0, 0.50],
            [Combat.ATTACK,  0.35, ("g_02",),          1200.0, 2000.0, 3000.0, 0.50],   #Rhook
            [Combat.ATTACK,  0.35, ("g_07",),          1200.0, 2000.0, 3000.0, 0.50],   #Lhook
            [Combat.ATTACK,  0.007, ("g_mgc02",),      1600.0, 7000.0, 25000.0, 0.50],  # spit
]



##########################################################################################################################################################
######## Wobbly stuff




Bladex.AddParticleGType("VeryDeepBlueEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,20)

for i in range(20):
	if i>3:
		traux=1.0
		saux=((20.0-i)/17.0)**2.0 #va de 0 a 1
	else:
		saux=traux=i/3.0 #va de 1 a 0
	r=10
	g=10
	b=50
	a=255.0*traux
	size=100.0*saux
	Bladex.SetParticleGVal("VeryDeepBlueEnergyConc",i,r,g,b,a,size)


	

Bladex.AddParticleGType("VeryDeepBlueMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/25.0 #va de 1 a 0
		aux=traux**2.0
	r=10
	g=10
	b=60
	a=255.0*traux
	size=400.0*aux
	Bladex.SetParticleGVal("VeryDeepBlueMagicMissile",i,r,g,b,a,size)



class SmallWobbly(ItemTypes.PersistantItemType):
	DamageEntityName=""
	Name=""
	OwnerName=""
	Hit=0
	Fired=0
	MissileShootSound=None
	MissileWhileSound=None
	MissileImpactSound=None
	ThrownBy=None
	FirePS=None
	TargetName=""
	
	def __init__(self, me, ownerName,enemyName):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.CastShadows= 0
		me.Visible= 0
		me.Flick=1
		me.Color=140, 255, 160
		me.Intensity=0.0
		me.Damage=1
		me.DamageRadius=500.0

		ball=Bladex.CreateEntity(me.Name+"_Shell", "EsferaUmbBall", 0,0,0)
		ball.Orientation=0.707107,0.707107,0.000000,0.000000
		ball.Scale=0.4
		ball.RasterMode="Read"
		ball.RasterMode="AdditiveAlpha"
		ball.Alpha=0.0
		ball.SelfIlum=0.5
		ball.CastShadows=0

		AuxFuncs.FadeObject(ball.Name, 0.0, 0.99, 2.0)

		self.DamageEntityName=ball.Name
		self.Name=me.Name
		self.OwnerName=ownerName
		self.TargetName=enemyName
		self.Hit=0
		self.Fired=0

		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, self.IntensityVarWithoutTimer, (0.1, 2.0))

		# Create and link a particle system here
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.CreateFireball, ())

		me.OnHitFunc=self.PrevOnHitFunc
		me.InflictHitFunc= self.BolaDalGurakInflictHitFunc
		me.TimerFunc=self.MoveAndRotateBall
		me.SubscribeToList("Timer30")

		# Create an energy concentration effect here for 1.0 second		
		concball=Bladex.CreateEntity(me.Name+"_Conc","Entity Particle System Dobj", 0, 0, 0)
		concball.ObjectName=ball.Name
		concball.ParticleType="VeryDeepBlueEnergyConc" 
		concball.PPS=2000
		concball.YGravity=0.0
		concball.Friction=0.0
		concball.RandomVelocity=-5.0
		concball.NormalVelocity=-15.0
		concball.Time2Live=20
		concball.FollowFactor=0.1
		concball.DeathTime=Bladex.GetTime()+1.0

		concsound=Bladex.CreateEntity(me.Name+"ConcSound", "Entity Sound", 0, 0, 0)
		concsound.SetSound("..\\..\\Sounds\\energy-ball-conc.wav")
		concsound.MinDistance=5000
		concsound.MaxDistance=30000
		me.Link(concsound)
		concsound.PlaySound(0)

		self.SetMissileSound("shoot", "..\\..\\Sounds\\Fireball-Fire.wav")
		self.SetMissileSound("while", "..\\..\\Sounds\\energy-ball.wav")
		self.SetMissileSound("impact", "..\\..\\Sounds\\energy-ball-impact.wav")

		Bladex.AddScheduledFunc(Bladex.GetTime()+20.0, self.BallDissipation, (), "PostFunc"+me.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.ReleaseThrownWeaponHandler, (me.Name, ""))
		
		
		Reference.EntitiesObjectData[me.Name]= [Reference.OBJ_WEAPON, 0, 0, 2.0,  Reference.THR_SPINNING, []]
		Reference.EntitiesObjectData[self.DamageEntityName]= [Reference.OBJ_WEAPON, 0, 0, 2.0,  Reference.THR_SPINNING, []]
		if self.OwnerName:
			lvl=Bladex.GetEntity(self.OwnerName).Level+1
			wdam=lvl*100
			Reference.EntitiesObjectData[me.Name][1]=wdam
			Reference.EntitiesObjectData[self.DamageEntityName][1]=wdam
			print "set wobbly damage"
		
			


	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		MissileShootSoundName= ""
		MissileWhileSoundName= ""
		MissileImpactSoundName= ""
		ThrownByName=""
		FirePSName=""
		if self.MissileShootSound: MissileShootSoundName= self.MissileShootSound.Name
		if self.MissileWhileSound: MissileWhileSoundName= self.MissileWhileSound.Name
		if self.MissileImpactSound: MissileImpactSoundName= self.MissileImpactSound.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.FirePS: FirePSName= self.FirePS.Name
		
		state[1]["SmallWobbly"]=(self.DamageEntityName,
					 self.Name,
					 self.OwnerName,
					 self.TargetName,
				         self.Hit,
					 self.Fired,
					 MissileShootSoundName,
					 MissileWhileSoundName,
					 MissileImpactSoundName,
					 ThrownByName,
					 FirePSName)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["SmallWobbly"]
			MissileShootSoundName=""
			MissileWhileSoundName=""
			MissileImpactSoundName=""
			ThrownByName=""
			FirePSName=""
			
			(self.DamageEntityName,
			self.Name,
			self.OwnerName,
			self.TargetName,
			self.Hit,
			self.Fired,
			MissileShootSoundName,
			MissileWhileSoundName,
			MissileImpactSoundName,
			ThrownByName,
			FirePSName)= parms
			
			if MissileShootSoundName: 
				self.MissileShootSound= Bladex.GetEntity(MissileShootSoundName)
			if MissileWhileSoundName: 
				self.MissileWhileSound= Bladex.GetEntity(MissileWhileSoundName)
			if MissileImpactSoundName: 
				self.MissileImpactSound= Bladex.GetEntity(MissileImpactSoundName)
			if ThrownByName:
				self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if FirePSName:
				self.FirePS=Bladex.GetEntity(FirePSName)
		
		if self.Name:
			me=Bladex.GetEntity(self.Name)
			if me:
				me.OnHitFunc=self.PrevOnHitFunc
				me.InflictHitFunc= self.BolaDalGurakInflictHitFunc
				me.TimerFunc=self.MoveAndRotateBall
				me.SubscribeToList("Timer30")




	def SetMissileSound(self, kind, wavfile):
		missile=Bladex.GetEntity(self.Name)
		if missile:
			if kind=="shoot":
				missilesound=Bladex.CreateEntity(self.Name+"ShootSound", "Entity Sound", 0, 0, 0)
				self.MissileShootSound=missilesound
			elif kind=="while":
				missilesound=Bladex.CreateEntity(self.Name+"WhileSound", "Entity Sound", 0, 0, 0)
				self.MissileWhileSound=missilesound
			elif kind=="impact":
				missilesound=Bladex.CreateEntity(self.Name+"ImpactSound", "Entity Sound", 0, 0, 0)
				self.MissileImpactSound=missilesound
			missilesound.SetSound(wavfile)
			missilesound.Volume=1.0
			missilesound.MinDistance=5000
			missilesound.MaxDistance=30000
			missile.Link(missilesound)



	def BallDissipation(self):
		missile=Bladex.GetEntity(self.Name)
		ball=Bladex.GetEntity(self.DamageEntityName)
		if missile:
			intred=0.2              #2.0/10.0
			escred=0.1 		#1.0/10.0
			rndvelred=-2.0 		#-20.0/10.0
			PPSred=150.0 		#1200/8.0
			Alphared=0.099 		#0.99/10.0
			sndred=0.1 		#1.0/10.0
			missile.Intensity=max(0.0, missile.Intensity-intred)
			ball.Scale=max(0.0, ball.Scale-escred)
			ball.Alpha=max(0.0, ball.Alpha-Alphared)
			self.FirePS.RandomVelocity=self.FirePS.RandomVelocity-rndvelred
			self.FirePS.PPS=max(10.0, self.FirePS.PPS-PPSred)
			self.MissileWhileSound.Volume=max(0.0, self.MissileWhileSound.Volume-sndred)
			if missile.Intensity>0.0:
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1, self.BallDissipation, (), "PostFunc"+self.Name)
			else:
				self.FirePS.DeathTime=Bladex.GetTime()+1.0/60.0
				missile.Unlink(self.FirePS)
				missile.SubscribeToList("Pin")
				ball.SubscribeToList("Pin")
				self.MissileShootSound=None
				self.MissileWhileSound=None
				self.MissileImpactSound=None
				self.ThrownBy=None
				self.FirePS=None
		elif ball:
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None


	def DissipateConc(self):
		shootball=Bladex.CreateEntity(self.Name+"_Shoot","Entity Particle System Dobj", 0, 0, 0)
		shootball.ObjectName=self.DamageEntityName
		shootball.ParticleType="VeryDeepBlueMagicMissile"
		shootball.PPS=1000
		shootball.YGravity=0.0
		shootball.Friction=0.0
		shootball.RandomVelocity=5.0
		shootball.NormalVelocity=20.0
		shootball.Time2Live=30
		shootball.DeathTime=Bladex.GetTime()+0.5


	def IntensityVarWithoutTimer(self, intvar, end_int):
		missile=Bladex.GetEntity(self.Name)
		if missile:
			missile.Intensity=missile.Intensity+intvar
			if missile.Intensity>=end_int:
				missile.Intensity=end_int
			else:
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1, self.IntensityVarWithoutTimer, (intvar, end_int))


	def MoveAndRotateBall(self, ent_name, time):
		missile=Bladex.GetEntity(ent_name)
		if missile:
			ball=Bladex.GetEntity(self.DamageEntityName)
			ball.Position=missile.Position
			ball.RotateRel(0.0, 0.0, 0.0, 0, 0, 1, -0.5)


	def CreateFireball(self):
		rayo1=Bladex.CreateEntity(self.Name+"_Ray1", "Entity ElectricBolt", 0.0, 600.0, 600.0)
		rayo1.Target=0.0, -600.0, -600.0
		rayo2=Bladex.CreateEntity(self.Name+"_Ray2", "Entity ElectricBolt", 0.0, 600.0, -600.0)
		rayo2.Target=0.0, -600.0, 600.0
		rayo1.FixedTarget=rayo2.FixedTarget=0
		rayo1.MaxAmplitude=rayo2.MaxAmplitude=600
		rayo1.MinSectorLength=rayo2.MinSectorLength=10000
		rayo1.Damage=rayo2.Damage=0
		rayo1.Active=rayo2.Active=1
		rayo1.CoreGlowColor=rayo2.CoreGlowColor=20.0, 20.0, 50.0
		rayo1.InnerGlowColor=rayo2.InnerGlowColor=10.0, 10.0, 50.0
		rayo1.OuterGlowColor=rayo2.OuterGlowColor=0.0, 0.0, 0.0
		ball=Bladex.GetEntity(self.DamageEntityName)
		ball.Link(rayo1)
		ball.Link(rayo2)
		fireball=Bladex.CreateEntity(self.Name+"_Fire","Entity Particle System D1",0,0,0)
		fireball.ParticleType="VeryDeepBlueMagicMissile"
		fireball.PPS=400
		fireball.YGravity=0.0
		fireball.Friction=0.04
		fireball.RandomVelocity=-16.0
		fireball.FollowFactor=0.4
		fireball.Time2Live=30
		missile=Bladex.GetEntity(self.Name)
		missile.Link(fireball)
		self.FirePS=fireball


	def SetTarget(self, EntityName, OwnerName):
		missile=Bladex.GetEntity(EntityName)
		print "Aiming Wobbly for ",OwnerName
		
		if missile:
			target=Bladex.GetEntity(self.TargetName)
			if target:
				missile.ETarget=self.TargetName
				print "Wobbly Target set"
			else:
				print "Nooooooooooooo wobbbbbbly Tarrrrget"
				
				
				
		
			

	def ReleaseThrownWeaponHandler (self,EntityName,EventName):
		if self.Fired:
			return
		self.Fired=1
		me= Bladex.GetEntity(EntityName)
		if not me:
			return
		if not self.OwnerName:
			return
		owner= Bladex.GetEntity(self.OwnerName)
		if not owner:
			return
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.SetTarget, (EntityName, self.OwnerName))
		me.Velocity=owner.Rel2AbsVector(0.0, -3500.0, 0.0)
		self.MissileShootSound.PlaySound(0)
		self.MissileWhileSound.PlaySound(-1)
		self.ThrownBy= owner  # this pointer may not be valid
		self.DissipateConc()
		



	def BolaDalGurakInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		# Called on the impact of the ball on an Entity
		# NOTE: if the Damage parameter has been set to 0, this function will not be called.
		#print EntityName+" inflicting hit to "+VictimName
		#if self.OwnerName:
		#	owner=Bladex.GetEntity(self.OwnerName)
		#	owner.Data.FiringWobbly=0
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.DestroyBall,(EntityName,),"DestroyBall"+EntityName)
		
		
		
		if VictimName != "BWorld" and VictimName != self.OwnerName and VictimName != self.DamageEntityName:
			ball=Bladex.GetEntity(self.DamageEntityName)
			if ball:
				if not self.Hit:
					self.Hit= 1
					victim= Bladex.GetEntity(VictimName)
					#print " Fire hitting "+VictimName
					if victim.Person:
						Bladex.RemoveScheduledFunc("PostFunc"+self.Name)
						ball.Alpha=0.99
						victim.DamageFunc(VictimName, self.OwnerName, self.DamageEntityName, "Fire", 1, -1, ImpX, ImpY, ImpZ, 0)
						# Override hurt anim
						if victim.Life>0:
							if victim.InCombat:
								victim.Wuea=Reference.WUEA_ENDED
								victim.InterruptCombat()
								victim.LaunchAnmType("hurt_f_big")
							else:
								victim.Wuea=Reference.WUEA_ENDED
								victim.InterruptCombat()
								victim.LaunchAnmType("hurt_f_big")
						self.OnHitFunc(self.Name,VictimName)
					elif victim.Weapon:
						if Reference.IsParryingType(victim.Kind):
							Bladex.RemoveScheduledFunc("PostFunc"+self.Name)
							ball.Alpha=0.99
							Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, self.BallDissipation, (), "PostFunc"+self.Name)
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.DestroyBall,(EntityName,),"DestroyBall"+EntityName)
		
		
		
		
		

	def BallExpansion(self, ent_name, time):
		alpha_var=-0.066 		#(0.0-0.99)/(0.5*30.0)
		scale_var=0.133 #(3.0-1.0)/(0.5*30.0)
		y_var=60.0                      #900.0/(0.5*30.0)
		ball=Bladex.GetEntity(ent_name)
		x, y, z=ball.Position
		ball.Position=x, y+y_var, z
		ball.RotateRel(0.0, 0.0, 0.0, 0, 0, 1, -0.5)
		ball.Alpha=max(0.0, ball.Alpha+alpha_var)
		ball.Scale=ball.Scale+scale_var
		if ball.Scale>=1.2:
			ball.RemoveFromList("Timer30")
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None


	def PrevOnHitFunc (self, EntityName, hit_entity):
		# Called on the impact of the ball with the world, or an Entity (if Damage parameter==1)
		if not hit_entity:
			self.OnHitFunc(EntityName, hit_entity)


	def OnHitFunc (self, EntityName, hit_entity):
		ball_name=self.DamageEntityName
		ball=Bladex.GetEntity(ball_name)
		print "hulk ball Hit"
		x, y, z=ball.Position
		ball.SelfIlum=1.0
		impactlight=Bladex.CreateEntity(ball_name+"ImpactLight", "Entity Spot", x, y-800.0, z)
		impactlight.Color=140, 255, 160
		impactlight.Intensity=4.0
		impactlight.Precission=0.1
		impactlight.CastShadows=0
		impactlight.Flick=0
		impactlight.Visible=0
		AuxFuncs.SpotIntensityVariation(impactlight.Name, 4.0, 0.0, 1.4, 1)
		if self.MissileWhileSound: 
			self.MissileWhileSound.StopSound()
		if self.MissileImpactSound: 
			self.MissileImpactSound.PlaySound(0)
		victim= Bladex.GetEntity(hit_entity)
		if victim and victim.Person:
			impactps=Bladex.CreateEntity(ball_name+"ImpactPS", "Entity Particle System Dperson", 0, 0, 0)
			impactps.PersonName=hit_entity
			impactps.ParticleType="VeryDeepBlueMagicMissile"
			impactps.PPS=600
			impactps.YGravity=2000.0
			impactps.Friction=0.0
			impactps.RandomVelocity=5.0
			impactps.NormalVelocity=25.0
			impactps.Velocity=0.0, -1000.0, 0.0
			impactps.Time2Live=30
			impactps.DeathTime=Bladex.GetTime()+0.4
		ball.TimerFunc=self.BallExpansion
		ball.SubscribeToList("Timer30")
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.DestroyBall,(EntityName,),"DestroyBall"+EntityName)
		missile=Bladex.GetEntity(self.Name)
		missile.RemoveFromList("Timer30")
		missile.SubscribeToList("Pin")
		self.MissileShootSound=None
		self.MissileWhileSound=None
		self.MissileImpactSound=None
		self.ThrownBy=None
		self.FirePS=None
		if Reference.EntitiesObjectData.has_key(EntityName):
			del Reference.EntitiesObjectData[EntityName]
		
	
			


	def DestroyBall(self,EntityName):
		ball_name=self.DamageEntityName
		ball=Bladex.GetEntity(ball_name)
		if ball: 
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None
		

	

def MakeSmallWobblyBall (name, x,y,z, ownerName="",enemyName=""):
	missile= Bladex.CreateEntity(name, "Entity Magic Missile", x, y, z)
	missile.Data= SmallWobbly (missile, ownerName,enemyName)
	print "Making wobbly for ",ownerName
	return missile




class UmberhulkBackShield:
	def __init__(self, me, owner):
		self.ObjId=ObjStore.GetNewId() 
		ObjStore.ObjectsStore[self.ObjId]=self

		self.Name= me.Name
		self.OwnerName= owner
		me.ExclusionMask=2|4
		me.Weapon= 1
		me.Alpha= 0.8
		#me.RasterMode="Read"
		#me.RasterMode="AdditiveAlpha"
		me.Solid= 0
		me.CastShadows=0
		me.HitFunc= self.TakeImpact
		
		self.bangsnd=Bladex.CreateSound('..\\..\\sounds\\M-impacto-berrera-22.wav', 'BangSnd')
		self.bangsnd.Volume=1.0
		self.bangsnd.MinDistance=1000
		self.bangsnd.MaxDistance=20000


	def TakeImpact (self,hit_entity, hitting_entity, xhit_point, yhit_point, zhit_point, ximpulse, yimpulse, zimpulse,wcx,wcy,wcz,wdx,wdy,wdz):
		obj= Bladex.GetEntity(hitting_entity)
		print "Bong"
		self.bangsnd.Play(xhit_point, yhit_point, zhit_point,0)
		
		if Reference.DefaultObjectData.has_key(obj.Kind):
			data=Reference.DefaultObjectData[obj.Kind]
			flag=data[0]
		else:
			return
		if flag==Reference.OBJ_WEAPON or flag==Reference.OBJ_ARROW or flag==Reference.OBJ_STANDARD:
			obj.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			obj.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			#if self.OwnerName:
			#	pj=Bladex.GetEntity(self.OwnerName)
			#	pj.Data.IncrementBackHitCounter()
			
			sparkdir=B3DLib.Normalize((-ximpulse, -yimpulse, -zimpulse))
			chispa=Bladex.CreateSpark("Chispa", xhit_point, yhit_point, zhit_point, sparkdir[0], sparkdir[1], sparkdir[2],0.5,3000,2000,0,100, 160, 120, 40, 30, 24, 0,800,10.0/60.0,1.0/60.0,1)
			if flag != Reference.OBJ_ARROW:
				hitter=Bladex.GetEntity(obj.Parent)
				if hitter:
					hitter.Wuea=Reference.WUEA_ENDED
					hitter.InterruptCombat()
					hitter.LaunchAnmType("sw_react")


	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,self.ObjId,
			  self.Name,
			  self.OwnerName)


	def __setstate__(self,parm):
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=parm[2]
			self.OwnerName=parm[3]
		else:
			self.ObjId=ObjStore.GetNewId() 
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Name=""
			self.OwnerName=""
			
		self.bangsnd=Bladex.CreateSound('..\\..\\sounds\\M-impacto-berrera-22.wav', 'BangSnd')
		self.bangsnd.Volume=1.0
		self.bangsnd.MinDistance=1000
		self.bangsnd.MaxDistance=20000

		
	
	


	

def MakeBackShield(name,owner):
	shd=Bladex.CreateEntity(name,"Ubackshd",0,0,0)
	shd.Static=0
	shd.Scale=1.2
	shd.SelfIlum=0.8
	shd.Data=UmberhulkBackShield(shd,owner)
	return shd
	

	


	

	
	
	






	
